//========================================================================// 
//    The NomadHead-System-Project                                                   
//    by                                                                     
//    Rytta Communications Inc.                                           
//    (c) Version 0.207. March 2010                                         
//                                                                          
//========================================================================// 
//    audioWriter0207.cpp   (ex audioWriter11.cpp)                                                        
//    -------------------
//                                                              
//    begin        : Wed. 11. March 10.15:00 GMT 2009                          
//    copyright    : (C) 2003/2006/2009/2010 by  s.morf                                    
//    email        : stevenmorf@bluewin.ch                                   
//    compile with 
//    USB-SerialCom
//    to Laptop    : g++ audioWriter11.cpp -o audioWriter11

//    compileScript: ./compileScript_87.sh 
//
//     as           : - Main: nomadHeadSystem0207.cpp  
//                    - Sub1: redBallTracking0207.cpp  
//                    - Sub2: servoTracking0207.cpp 
//                    - Sub3: headSensor0207.cpp
//                    - Sub4; bodyTracking0207.cpp  
//                    - Sub5: simBehavior0207.cpp    
//                    - Sub6: audioWriter0207.cpp
//     
//     run as    : ./nomadHeadSystem0207
                                
//************************************************************************** 
//     THIS PROGRAMM IS UNDER THE GNU-LICENCE                              
/***************************************************************************  
    This program is free software; you can redistribute it and/or modify    
it under the terms of the GNU General Public License as published by the Free
Software Foundation; either version 2 of the License, or (at your option) any
later version.                                                                
                                             
****************************************************************************************************
NEW NOTES:
New Version: 08.03.2010
08.03. - frist stage for soundBehavior (1)
         - on quad as testing app: audioWriter11.cpp
           - send soundcommands to laptop (NO  WAIT FOR RECEIVE COM_DONE)
             on laptop into /Desktop/NomadHeadSystem/festival
             - audioReader11.cpp
               - receive commands from quad and with FESTIVAL make the sound
                 - here under: into: /root/Desktop/Audio/
09.03. - rs232-port under /dev/ gem. untenStehender
         - doku = "/dev/ttyS0" 
       - on quad: 1. entwicklungen
         - rs232 send
           - on laptop -> receiveDatas
       - 1.OnlineTests only rs232
         - here soweit OK
        
10.03. - beschraenke mich auf die verwendung von Festival Text-to_Speech
         with:
         input:
         1 = letter1.txt == Hello, i am Nomad.
         2 = letter2.txt == oooh, Yeah
         3 = letter3.txt == TschindradaBumps.
         4 = letter4.txt == FAILURE.
         5 = letter5.txt == EXIT.
       - 1.OnlineTests with Quad rs232 OK
                       with Laptop Festival & rs232 OK
11.03. - Now Todo here:
         - Integragtion of audioWriter11 into NHS_0206 -> new Version 0207
11.03. - New Version 0207 with audioWriter0207.cpp
       - 1. versuchsweise compile -> in servoTracking0207.cpp
            existieren bereits Vars aus audioWriter0207.cpp
            - Konflikte loesen
       - now comile original OK, konflikte geloest
       - now einbau von audioWriter into System
         - einsprung is:
           - ext_audioWrite(int antw);
         - 1) einbau into main as Init before while 
              - < 1 >
         - 2) einbau at EXIT
              1) sound = < 5 > Exit
              2) sendData <10> for exit-laptop 
       - 1. OnlineTests ohne Servos
            - no. 1 OK
            - no. 2 NOK NO Sound No EXIT LAPTOP
       - umbauten in ESC
       - 2. OnlineTest OK
            - no. 1 OK
            - no. 2 OK
              - sound <  5 > exit
              - exit  < 10 > exit audioReader11.cpp on Laptop 
      - 1.versuche here with audioWriter at
           - int redBallStateMachine()   
             - FEAR and ANGRY
               - with 
                 2 = letter2.txt == oooh, Yeah
                 3 = letter3.txt == TschindradaBumps.
           - einsprung is:
             - ext_audioWrite(int antw);
       - no. 3 is ok
       - no. 2 vermutlich auch aber wird nicht angesprungen 
       - Now OnlineTest with Servos
**************************************************************************************************

REFERENCES:
   1) FESTIVAL:  http://www.cstr.ed.ac.uk/projects/festival/download.html 

   2) Serial Com:
      - audioWriter: rs232Port = /dev/ttyS0 to Linux-Laptop
      - with
        - 9600 BAUD, no parity, 8 data-bits and 1 stop bit
      
   3) Logitec Webcam E3500 E
   1. unplug your cam 
   2. modprobe -r uvcvideo 
   3. modprobe -r snd_usb_audio 
   4. replug your cam    
***************************************************************************************************/ 
#include<iostream>

#include <math.h>

// C-Stuff for RS232
#include <stdio.h>
#include <stdlib.h>

#include <fcntl.h> 
#include <string.h> 
#include <ctype.h> 

#include <setjmp.h> 
#include <termios.h> 
#include <unistd.h> 
#include <sys/signal.h> 
#include <sys/types.h> 
#include <errno.h> 
#include "curses.h"      
#include <ctype.h>
#include <sys/io.h> 

#include <time.h>
#include <sys/stat.h>
#include <string.h>

#include <sstream>
 
using namespace std;

#define _POSIX_SOURCE 1  	    // POSIX compliant source  

// new for communications 
#define BAUDRATE_AUDIO   B9600   // baudrate settings for commands mots                                 
#define MODEMDEVICE_AUDIO "/dev/ttyS0"   

#define MAXTOKLEN 255  // for tokenizer
#define BUFLEN 255
#define S_MAXTOKLEN 8

extern struct termios oldtio,newtio, options; 

int fw_audio;     // w=write 
int fr_audio;     // r=read
int audio_slen;
int audio_n; 
int audioAntw; // for output

char *audioSendDataStr;
char audioSendData[12];  // for umwandlung int to string with sprintf
const char *audioSendEOF = ("\r");
const char *exitLaptop = "10\r";
bool audioComDone;
bool audioDone;
bool bool_AudioSenderDone;

// new sequences
int audioState;
int AudiooldState;



/*************************************************************************** 
* Don't forget to give the appropriate serial ports the right permissions  *
* (e. g.: chmod a+rw /dev/ttyS0)!                                          *
* baudrate settings are defined in <asm/termbits.h>, which is              *       
* included by <termios.h>   ==  system(init_2);                            *  
**************************************************************************** 
/*** from conio.h *********************************************************/

void gotoxy(int x, int y);
void clrscr(void);

// delay (nnn)
void delay(long millisek);
/***************************************************************************************************/
int audioSender()
  {
     printf("Communications: AudioSender: %s\n",audioSendDataStr); 

     fw_audio = open(MODEMDEVICE_AUDIO, O_WRONLY | O_NOCTTY );        // old O_RDWR 
     if(fw_audio <0)
        {
           perror(MODEMDEVICE_AUDIO);
           printf("cannot open ttyS0");         
           
           exit(-1); 
        }
     tcgetattr(fw_audio,&oldtio);                // save current serial port settings 
     bzero(&newtio,sizeof(options));        // clear struct for new port settings 

     fcntl(fw_audio, F_SETFL,0);
     if(tcgetattr(fw_audio, &options) != 0) return(-1);
     cfsetspeed(&options,B9600); 
     /*setze Optionen */
      
     options.c_cflag &= ~PARENB;  // NO PARITYBIT
     options.c_cflag &= ~CSTOPB;  // 1 STOPPBIT
     options.c_cflag &= ~CSIZE;   // 8 DATENBIT 
     options.c_cflag |= CS8;
     options.c_cflag |= (CLOCAL | CREAD);  // CD-SIGNAL IGNORE
     // kein echo, keine steuerzeichen, keine interrupts
     
     options.c_lflag &= ~(ICANON | ECHO | ECHOE | ISIG);
     
     options.c_oflag &= ~OPOST;  // SETZE RAW-INPUT
     
     options.c_cc[VTIME]  = 10;    /* TIMEOUT 10 SEKUNDEN */ 
     options.c_cc[VMIN]  = 0;      /* wait auf min. 0 zeichen old blocking read  until 1 character arrives */ 
  
     // now clean the modem line and activate the settings for the port  
     tcflush(fw_audio, TCIFLUSH);
  
     if(tcsetattr(fw_audio,TCSAFLUSH, &options) != 0) return (-1); 

     // here new write to Laptop for Audio FESTIVAL
     write(fw_audio,audioSendDataStr,audio_slen);  
        
     /* restore the old port settings */
     
     tcsetattr(fw_audio,TCSANOW,&oldtio); 
     close(fw_audio);
     
     printf("Sender is closed\n");
     
     bool_AudioSenderDone = false;
           
  } // end Sender  

/*** audioController ******************************************************************************/
int audioControl()
  {
     printf("AudioControl\n");
     
     /*
       1 = letter1.txt == Hello, i am Nomad.
       2 = letter2.txt == oooh, Yeah
       3 = letter3.txt == TschindradaBumps.
       4 = letter4.txt == FAILURE.
       5 = letter5.txt == EXIT.
      10 = exit;
     */

     if(audioAntw > 0)
        {
           printf("Command: %d \n",audioAntw);
                  
           audio_n = sprintf (audioSendData, "%d ", audioAntw);
           //printf ("[%s] is a %d char long string\n",audioSendData,audio_n);
                   
           printf("SendData: %s\n",audioSendData); 
          
           audioSendDataStr = (char *)malloc(strlen(audioSendData));  
           strcpy(audioSendDataStr,audioSendData); 
           
           audio_slen = strlen(audioSendEOF); 
           strncat(audioSendDataStr,audioSendEOF,audio_slen); 
           audio_slen = strlen(audioSendDataStr); 
           
           // printf("Audio_S_Len: %d\n",audio_slen); 
           // printf("AudioSendDataString: %s\n",audioSendDataStr);

           audioSender();
        }   
          
     if(audioAntw == 10)
        {
           audioComDone = true; 
           clrscr();
           printf("Audio-Exit with <10>\n");
        }
  }    
/*** main *****************************************************************************************/
void ext_audioWrite(int antw)
  {
     printf("AudioWriter\n");

     audioAntw = antw;
      
     audioComDone = false; 
           
     audioControl();
         
     if(audioComDone == true)
        {
           audioDone = true;
            
        }

   } 
/**************************************************************************************************/
