  //============================================================================================//
//    The Nomad-Head-System-Project                                                   
//    by                                                                    
//    Rytta Communications Inc.                                           
//    (c) Version 0.0207. March 2010
//
//    BASICS  - cvColor -> drawing white contour of BodyPieces (skinColor + b/w)
//            - snippets from nomadVision1.cpp -> drawing redContour
                
//    EXPERIMENTAL -> TESTING NEW COMMUNICATIONS                                      
//    Stripping OpenGL only OpenCV & SerialCom     
//    for NomadHeadSystem                                                                 
//===========================================================================================// 
//     bodyTracking0207.cpp   ( ex. cvBodyTracking10.cpp )
//     --------------------    
//     
//     begin     : Thursday 11. March 10.15:00 GMT 2010                            
//     copyright : (C) 2008/2009/2010 by  s.morf 
//     email     : stevenmorf@bluewin.ch 
//     originalCompile with   
//     opencv   
//     g++ -I/usr/local/include/opencv -L /usr/local/lib -lcxcore -lcv -lhighgui -lcvaux -lml -o cvBodyTracking10 cvBodyTracking10.cpp -lm 

//     compileScript: ./compileScript_87.sh 
//
//     as           : - Main: nomadHeadSystem0207.cpp  
//                    - Sub1: redBallTracking0207.cpp   
//                    - Sub2: servoTracking0207.cpp 
//                    - Sub3: headSensor0207.cpp
//                    - Sub4: bodyTracking0207.cpp
//                    - Sub5: simBehavior0207.cpp     
//                    - Sub6: audioWriter0207.cpp
//     
//     run as    : ./nomadHeadSystem0207
//
//    for: 
//    Basics of : - ComputerVisions with 2 USB-WebCams as Eyes
//                  - with (pthreads options)
//                  - OpenCV 
//                     - bodyTracking 
//                    - 2 x WebCams
//                  - comControl with  
//                    - SerialControl of CamHeadSystem via PropDevBoard
//                      - 3 DOF (Nick & Turn & opt.Roll)
//                      - horizontal Turns of CamServos                
//
/*************************************************************************************************
References:

  Copyright (C) 2007 Julian Oliver
  http://julianoliver.com

  Modifications
  Copyright (C) 2008 Jean-Philippe Deblonde
  http://www.lifl.fr/~deblonde/

  verwendete programme:
  from /root/Desktop/OPENCV/opencv-tutorial.pdf (german)
  <Bildverarbeitung mit OpenCV, author Johannes Wienke, Uni Bielefeld 2008>

  OpenCV_Beispiele From RoboWeb
  Mehrere Bilder in einem Fenster
  from http://opencvlibrary.sourceforge.net/DisplayManyImages.

  Display video from webcam

  lucasKanadeAlgorithmus: from
  cvLkDemo1.cpp from samples/c/ (lkdemo.c -> erkennt face (frontal)
  lkdemo.c from book "learning opencv" /samples/c/
  if <r> automatical Init
  "Learning OpenCV-Book"
 
  Author  Nash
  License GPL
  Website http:/nashruddin.com

  OpticalFlow from
  David Stavens
  Standford Artificial Intelligence Lab (PDF)

  3d distance tracking using head width
  name: headtracking1.cpp
  from:http://code.google.com/p/ehci/wiki/HeadTracking
 
  Ref: This code uses some approximations, but is a good starting point

  cvHandGesture original source code: hsv1.cpp
  from
  VERSION: HAND DETECTION 1.0
  AUTHOR: ANDOL LI@CW3/18, Live:lab
  PROJECT: HAND DETECTION PROTOTYPE
  LAST UPDATED: 03/2009

//************************************************************************************************/ 
//     THIS PROGRAMM IS UNDER THE GNU-LICENCE                              
/*************************************************************************************************  
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*************************************************************************************************/ 
// Sample Application to demonstrate how Face detection can be done as a part of your source code.
// as *.cpp source
// Grabbing Images from two cameras simultaneously
// Note: Here we are using USB cameras 
/*************************************************************************************************
NOTES:

/*************************************************************************************************/
#include<iostream>

#include "cv.h"
#include "cxcore.h"
#include "highgui.h"

#include "math.h"
#include <stdio.h>
#include <string.h>
#include <time.h>

#include <sstream>

using namespace std;

/*************************************************************************************************/

//Some defines we left out of the book
#define CVX_RED   CV_RGB(0xff,0x00,0x00)
#define CVX_GREEN CV_RGB(0x00,0xff,0x00)
#define CVX_BLUE  CV_RGB(0x00,0x00,0xff)

int I,J,K;    
int HEIGHT,WIDTH,STEP,CHANNELS; 
int STEPR, CHANNELSR;           
int TEMP;                       

uchar *DATA,*DATAR;            
CvCapture *CAPTURE;             
IplImage *FRAME;               
IplImage *RESULT1;              

int XP,YP;
CvPoint PT1,PT2;   //pt1,pt2;
CvPoint* PT[2];    //pt[2];

int LEVELS = 3;    // levels = 3;
CvSeq* CONTOURS = 0;   // *cocontours = 0;

int cvWorkCounter;

// bodyContours
IplImage* IMG_8UC1;     
       
IplImage* IMG_EDGE; 
IplImage* IMG_8UC3;
;
CvMemStorage* STORAGE1;
CvSeq* FIRST_CONTOUR;
CvSeq* C;
      
int NC; 
int N = 0,KK;

// myBox1)
struct points
  {
     int x;
     int y;
  } BODYBOX;  

// Declare font
CvFont myFont;

CvSeq *A; 
CvSize SZ;

IplImage *SRC;
IplImage *HSV_IMAGE;
IplImage *HSV_MASK;
IplImage *HSV_EDGE;

IplImage *CONTOUR;
      
CvScalar HSV_MIN;
CvScalar HSV_MAX;
     
CvMemStorage *STORAGE;
CvMemStorage *AREASTORAGE;
CvMemStorage *MINSTORAGE;
CvMemStorage *DFTSTORAGE;

// CvSeq *contours = NULL;
CvSeq *CONTOURS2 = NULL;

IplImage *BG;
CvRect RECT;

CvSeq *HULL;
CvSeq *DEFECT;

CvBox2D BOX;

double RESULT, RESULT2; 
int CHECKCXT;

int DEF[10];
float TDEF;
int IDEF;

// NEW STUFF FROM HeadTrackCommunications4.cpp
// target
int BCENTERX = 320;
int BCENTERY = 240;

int BCAMX = BCENTERX;
int BCAMY = BCENTERY;

// myBox
struct TPOINTS
  {
     int x1;
     int y1;
     int x2;
     int y2; 
     int width;
     int height; 
  } TARGETBOX;  

// myBox1)
struct POINTS
  {
     int x;
     int y;
  } BODYDBOX;  

bool BTRACKINIT   = false;
bool BOBENLINKS   = false;
bool BOBENRECHTS  = false;
bool BUNTENRECHTS = false;
bool BUNTENLINKS  = false;

bool BOOLBODYTARGET = false; 

bool BODYDONEOLX = false;
bool BODYDONEOLY = false;
bool BODYDONEULX = false;
bool BODYDONEULY = false;
bool BODYDONEORX = false;
bool BODYDONEORY = false;
bool BODYDONEURX = false;
bool BODYDONEURY = false;

bool BODYDONEX = false;
bool BODYDONEY = false;


/**************************************************************************************************/
// extern Vars
// extern Vars
extern int CamServo0;   // = 11500;  
extern int RollServo1;  // = 21660;  new Head guckt geradeaus  old: 21_660 
extern int NickServo2;  // = 31340;  new Head guckt geradeaus mit Schale  Kinn on whiteBlock old: 31400;  
extern int TurnServo3;  // = 41400; 
extern int WingServo;   // = 51300;
 
extern int centerAllServos;
extern int centerCamServo0;
extern int centerRollServo1;
extern int centerNickServo2;
extern int centerTurnServo3;   
extern int centerWingServo;

extern int newCamServo;
extern int newRollServo;
extern int newNickServo;
extern int newTurnServo;
extern int newWingServo;
extern int antw;  // = 0;

extern IplImage *frame1;
extern IplImage *frame2;
// behavior
extern IplImage *simImage;

extern bool RED_TRACK_KEYt;

extern bool RED_BALL_TRACK;
extern bool HEAD_TRACK; 
extern bool BACK_GROUND_TRACK;
extern bool WINDOW_TRACK;
extern bool LEARNING;

extern int camClick;
extern int rollClick;
extern int nickClick;

extern int camStep;
extern int rollStep;
extern int turnStep;
extern int nickStep; 

// MIN/MAX - ServoValues
// - CamServo:
extern int minLeftCamServo;     
extern int maxRightCamServo;  
// - RollServo:
extern int maxLeftRollServo;   
extern int minRightRollServo;  
// - NickServo:
extern int maxUpNickServo;     
extern int minDownNickServo;   
// - TurnServo:
extern int minLeftTurnServo;   
extern int maxRightTurnServo;    
// - WingServo:
extern int minLeftWingServo;   
extern int maxRightWingServo; 

extern int trackClick;

// behavior Erease In/out
extern int ii;  // x-dir Direction Line

// Behavior + Winglets Move
extern double X0;         // = StartWert0
extern int intX0;         // = for Winglets 
extern double Xf0;        // EndPosY 
extern int intXf0;        // endPoint slider
extern double weight0;    // gewichtungen 
extern int intWeight0;

// Calculations Behavior:
extern double behavior;
extern double factor;   // 0.0034482;  // 1.0 / 240
extern double normal;   //  = 240.0;
extern int step;
extern int oldstep;

extern int states;// Behavior + Winglets Move
extern double X0;         // = StartWert0
extern int intX0;         // = for Winglets 
extern double Xf0;        // EndPosY 
extern int intXf0;        // endPoint slider
extern double weight0;    // gewichtungen 
extern int intWeight0;

extern int onWindow;
extern int onBackGround;
extern int onHead;
extern int onRedBall;

extern bool onStartA;
extern bool onStopA;
extern bool onStartBG;
extern bool onQ;  
/************************************************************************************************/
// interne functionen
void HeadTrackCalc();
/*************************************************************************************************/
// extern Functions
int ext_servoTrackControl();
/**************************************************************************************************/
// sehr vereinfachte function
// obenlinks, obenrechts, untenrechts, untenlinks
int BodyTrackServo()   
  {
     printf("BodyTrackServo-Functions\n");

     if((BODYBOX.x > 300 ) && (BODYBOX.x < 340))  
        {
           BODYDONEX = true;
           printf("In the TargetX\n");
        }  int camStep  = 0;

     if((BODYBOX.y > 220 ) && (BODYBOX.y < 260))  
        {
           BODYDONEY = true;
           printf("In the TargetY\n");
        }     

     if((BODYDONEX == true) && (BODYDONEY == true))
        {
           printf("Is in the Midlle.......\n"); 
           goto endFunc;
        }
 
     // testen of left or right
     if((BOBENLINKS == true) || (BUNTENLINKS == true))
        { 
           if(BOBENLINKS == true) // bbxLine, bayLine
              {
                 // TurnStep
                 turnStep = 10;  
                 newTurnServo = TurnServo3 - turnStep;
                            
                 antw = newTurnServo;   
                 ext_servoTrackControl();

                 printf("BodyBox.x: %d, CamX: %d\n",BODYBOX.x,BCAMX); 
                 // printf("BODY: OBENLINKS NewTurnServo: %d , TurnServo3: %d \n",newTurnServo,TurnServo3);
                      
                 if((BODYBOX.x > 300 ) && (BODYBOX.x < 340))  
                    {
                       BODYDONEOLX = true;
                       printf("BodyTrack_X Done\n");
                    }   int camStep  = 0;

                 // NICKSERVO
                 nickStep = 10; 
                 newNickServo = NickServo2 + nickStep; 
                 
                 antw = newNickServo;
                 ext_servoTrackControl();      

                 printf("BodyBox.y: %d , CamY: %d\n",BODYBOX.y,BCAMY); 
                 // printf("Body: OBENLINKS NewNickServo: %d , NickServo2: %d\n",newNickServo,NickServo2);
                 
                 if((BODYBOX.y > 220 ) && (BODYBOX.y < 260))  
                    {
                       BODYDONEOLY = true;
                       printf("BodyTrack_Y Done\n");
                    }           

                 if((BODYDONEOLX == true) && (BODYDONEOLY == true))
                    {
                       printf(" All Done\n");
                            
                       // new Stuff
                       goto endFunc;
                    }
              }
           if(BUNTENLINKS == true) 
              {
                 // Turnstep
                 turnStep = 10;
                 newTurnServo = TurnServo3 - turnStep;
                 
                 antw = newTurnServo;   
                 ext_servoTrackControl();
               
                 printf("BodyBox.x: %d, CamX: %d\n",BODYBOX.x,BCAMX); 
                 // printf("Body: UNTENLINKS NewTurnServo: %d , TurnServo3: %d \n",newTurnServo,TurnServo3);
                 
                 if((BODYBOX.x > 300 ) && (BODYBOX.x < 340))  
                    {
                       BODYDONEULX = true;
                       printf("BodyTrack_X Done\n");
                    }   
                 
                 // NICKSERVO
                 nickStep = 10;
                 newNickServo = NickServo2 - nickStep;    // old +
                       
                 // Abfangen BickNickServoDown < 31_280
                 // minDownNickServo  = 31280;  
                 // - Down   min: 31_280 da bei tracking schon bei 31_274 Collision Podest

                 if(newNickServo < minDownNickServo) 
                    {
                        newNickServo = minDownNickServo; 
                        printf("BigNickServoDown\n");
                    }
                  
                 antw = newNickServo;
                 ext_servoTrackControl();
                       
                 printf("BodyBox.y: %d , CamY: %d\n",BODYBOX.y,BCAMY); 
                 // printf("Body: UNTENLINKS NewNickServo: %d , NickServo2: %d\n",newNickServo,NickServo2);
                 
                 if((BODYBOX.y > 220 ) && (BODYBOX.y < 260))  
                    {
                       BODYDONEULY = true;
                       printf("BodyTrack_Y Done\n");
                    }           
             
                 if((BODYDONEULX == true) && (BODYDONEULY == true))
                    {
                       printf(" All Done\n");
                            
                       // new Stuff
                       goto endFunc;
                    }
              } // end untenlinks
        } // end oben/untenlinks
 
     if((BOBENRECHTS == true) || (BUNTENRECHTS == true))
        {           
           if(BOBENRECHTS == true) // baxLine, bbyLine
              {  
                 // TURNSERVO
                 turnStep = 10;
                 newTurnServo = TurnServo3 + turnStep;
                       
                 antw = newTurnServo;   
                 ext_servoTrackControl();  
                 
                 printf("BodyBox.x: %d, CamX: %d\n",BODYBOX.x,BCAMX); 
                 // printf("Body: OBENRECHTS NewTurnServo: %d , TurnServo3: %d \n",newTurnServo,TurnServo3);
                      
                 if((BODYBOX.x > 300 ) && (BODYBOX.x < 340))  
                    {
                       BODYDONEORX = true;
                       printf("BodyTrack_X Done\n");
                    }   
 
                 // NICKSERVO 
                 nickStep = 10;
                 newNickServo = NickServo2 + nickStep; 
                              
                 antw = newNickServo;
                 ext_servoTrackControl();
               
                 printf("BodyBox.y: %d , CamY: %d\n",BODYBOX.y,BCAMY); 
                 // printf("Head: OBENRECHTS NewNickServo: %d , NickServo2: %d\n",newNickServo,NickServo2);
                 
                 if((BODYBOX.y > 220 ) && (BODYBOX.y < 260))  
                    {
                       BODYDONEORY = true;
                       printf("BodyTrack_Y Done\n");
                    }           

                 if((BODYDONEORX == true) && (BODYDONEORY == true))
                    {
                       printf(" All Done\n");
                            
                       // new Stuff
                       goto endFunc;
                    }
              }
           if(BUNTENRECHTS == true) // bayLine, bbxLine
              {
                 // TURNSERVO
                 turnStep = 10; 
                 newTurnServo = TurnServo3 + turnStep;
                       
                 antw = newTurnServo;   
                 ext_servoTrackControl();

                 printf("BodyBox.x: %d, CamX: %d\n",BODYBOX.x,BCAMX); 
                 // printf("Body: UNTENRECHTS NewTurnServo: %d , TurnServo3: %d \n",newTurnServo,TurnServo3);
                  
                 if((BODYBOX.x > 300 ) && (BODYBOX.x < 340))  
                    {
                       BODYDONEURX = true;
                       printf("BodyTrack_X Done\n");
                    }   
                                     
                 // NICKSERVO
                 nickStep = 10; 
                 newNickServo = NickServo2 - nickStep;    // old + 
                       
                 // Abfangen BickNickServoDown < 31_280
                 // minDownNickServo  = 31280;  
                 // - Down   min: 31_280 da bei tracking schon bei 31_274 Collision Podest
                        
                 if(newNickServo < minDownNickServo) 
                    {
                       newNickServo = minDownNickServo; 
                       printf("BigNickServoDown\n");
                    }
                     
                 antw = newNickServo;
                 ext_servoTrackControl();
                      
                 printf("BodyBox.y: %d , CamY: %d\n",BODYBOX.y,BCAMY); 
                 // printf("Body: UNTENRECHTS NewNickServo: %d , NickServo2: %d\n",newNickServo,NickServo2);
                 
                 if((BODYBOX.y > 220 ) && (BODYBOX.y < 260))  
                    {
                       BODYDONEURY = true;
                       printf("BodyTrack_Y Done\n");
                    }           

                 if((BODYDONEURX == true) && (BODYDONEURY == true))
                    {
                       printf(" All Done\n");
                            
                       // new Stuff
                       goto endFunc;
                    }
              } // end untenrechts
        } // end oben/unten rechts
    
    // new stuff
    endFunc:;  
   
    BODYDONEOLX = false;
    BODYDONEOLY = false;
    BODYDONEULX = false;
    BODYDONEULY = false;
    BODYDONEORX = false;
    BODYDONEORY = false;
    BODYDONEURX = false;
    BODYDONEURY = false;
    BODYDONEX   = false;
    BODYDONEY   = false;

  } 
/**************************************************************************************************/
void BodyTrackCalc()
  { 
     printf("BodyTrackCalc\n");
     
     printf("BodyBox.x: %d, BodyBox.y: %d\n",BODYBOX.x,BODYBOX.y);
     printf("BCAMX: %d, BCAMY: %d\n",BCAMX,BCAMY);  

     // draw BodyBox Rect 
     cvRectangle( IMG_8UC3, cvPoint( BODYBOX.x-20,BODYBOX.y-20 ), cvPoint( BODYBOX.x+20, BODYBOX.y+20 ), cvScalar(0xff,0xff,0x00),8,-1);   
     
     // new Stuff abfrage: if into Center of TargetBox
     if(((BODYBOX.x > TARGETBOX.x1) && (BODYBOX.x < TARGETBOX.x2)) &&
        ((BODYBOX.y > TARGETBOX.y1) && (BODYBOX.y < TARGETBOX.y2)))
        {
           printf("IS TARGET\n");  
           BOOLBODYTARGET = true;
        }  

      // (1) obenLinks:   
     if((BODYBOX.x < BCAMX) && (BODYBOX.y < BCAMY))
        {
           BOBENLINKS = true;
           
           printf("Body ObenLinks\n");

           // now draw a BX-Line to the center of the images:
           cvLine(IMG_8UC3,cvPoint(BODYBOX.x,BODYBOX.y),cvPoint(BODYBOX.x,BCAMY),cvScalar(0x00,0xff,0xff),4,8);  
           // now draw a AY-Lineine to the center of the images:
           cvLine(IMG_8UC3,cvPoint(BODYBOX.x,BCAMY),cvPoint(BCAMX,BCAMY),cvScalar(0x00,0x00ff,0xff),6,8);  
        }     
 
     // (2) obenrechts
     if((BODYBOX.x > BCAMX) && (BODYBOX.y < BCAMY))
        {
           BOBENRECHTS = true;
           
           printf("Body ObenRechts\n");

           // now draw a BX-Line to the center of the images:
           cvLine(IMG_8UC3,cvPoint(BODYBOX.x,BODYBOX.y),cvPoint(BODYBOX.x,BCAMY),cvScalar(0x00,0xff,0xff),4,8);  
           // now draw a AY-Lineine to the center of the images:
           cvLine(IMG_8UC3,cvPoint(BODYBOX.x,BCAMY),cvPoint(BCAMX,BCAMY),cvScalar(0x00,0x00ff,0xff),6,8);  
        }

     // (3) untenRechts:
     if((BODYBOX.x > BCAMX) && (BODYBOX.y > BCAMY))
        {
           BUNTENRECHTS = true;
           
           printf("Body UntenRechts\n");

           // now draw a BX-Line to the center of the images:
           cvLine(IMG_8UC3,cvPoint(BODYBOX.x,BODYBOX.y),cvPoint(BODYBOX.x,BCAMY),cvScalar(0x00,0xff,0xff),4,8);  
           // now draw a AY-Lineine to the center of the images:
           cvLine(IMG_8UC3,cvPoint(BODYBOX.x,BCAMY),cvPoint(BCAMX,BCAMY),cvScalar(0x00,0x00ff,0xff),6,8);  
        }

     // (4) untenLinks : 
     if((BODYBOX.x < BCAMX) && (BODYBOX.y > BCAMY))
        {
           BUNTENLINKS = true;
           
           printf("Body UntenLinks\n");

           // now draw a BX-Line to the center of the images:
           cvLine(IMG_8UC3,cvPoint(BODYBOX.x,BODYBOX.y),cvPoint(BODYBOX.x,BCAMY),cvScalar(0x00,0xff,0xff),4,8);  
           // now draw a AY-Lineine to the center of the images:
           cvLine(IMG_8UC3,cvPoint(BODYBOX.x,BCAMY),cvPoint(BCAMX,BCAMY),cvScalar(0x00,0x00ff,0xff),6,8);  
        }

     // 3.version von trackServo
     BodyTrackServo();
           
     BOBENLINKS   = false;
     BOBENRECHTS  = false;
     BUNTENRECHTS = false;
     BUNTENLINKS  = false;
     BOOLBODYTARGET = false;   
  } 

/*************************************************************************************************/
int BodyContours()
  {
     IMG_8UC1 = cvLoadImage("result.jpg",-1);     
       
     IMG_EDGE = cvCreateImage( cvGetSize( IMG_8UC1 ), 8, 1 );
     IMG_8UC3 = cvCreateImage( cvGetSize( IMG_8UC1 ), 8, 3 );
     cvThreshold( IMG_8UC1, IMG_EDGE, 128, 255, CV_THRESH_BINARY );
     STORAGE1 = cvCreateMemStorage();
     CvSeq* FIRST_CONTOUR = NULL;
      
     cvFindContours( IMG_EDGE, STORAGE1, &FIRST_CONTOUR, sizeof(CvContour), CV_RETR_LIST );
     CONTOURS2 = NULL;
     RESULT = 0, RESULT2 = 0; 
     
     while(FIRST_CONTOUR)
        {
           RESULT = fabs( cvContourArea( FIRST_CONTOUR, CV_WHOLE_SEQ ) );
                       
           if( RESULT > RESULT2 ) 
              {
                 RESULT2 = RESULT; CONTOURS2 = FIRST_CONTOUR;
              }
           FIRST_CONTOUR  =  FIRST_CONTOUR->h_next;
        }
     if( CONTOURS2 )
        {
           RECT = cvBoundingRect( CONTOURS2, 0 );
                    
           HULL = cvConvexHull2( CONTOURS2, 0, CV_CLOCKWISE, 0 );
           DEFECT = cvConvexityDefects( CONTOURS2, HULL, DFTSTORAGE );

           IDEF++;  
           DEF[IDEF] = DEFECT->total;
           
           if(IDEF == 10)
              {
                 TDEF = (float)(DEF[1]+DEF[2]+DEF[3]+DEF[4]+DEF[5]+DEF[6]+DEF[7]+DEF[8]+DEF[9]+DEF[10]) / 10.0;
                 printf("\n\nTDEF: %f\n\n",TDEF);
                 IDEF = 1;
              }   
           
           BOX = cvMinAreaRect2( CONTOURS2, MINSTORAGE );

           // erzeugt red HandContour                                                  // level 3
           cvDrawContours( IMG_8UC3, CONTOURS2, CV_RGB(255,0,0), CV_RGB(0,255,0), 2, 3, CV_AA, cvPoint(0,0) );
                                  
           cvCircle( IMG_8UC3, cvPoint(BOX.center.x, BOX.center.y), 3, CV_RGB(200, 0, 200), 2, 8, 0 ); 
           cvEllipse( IMG_8UC3, cvPoint(BOX.center.x, BOX.center.y), cvSize(BOX.size.height/2, BOX.size.width/2), BOX.angle, 0, 360, CV_RGB(220, 0, 220), 1, 8, 0 );
           
           BODYBOX.x = BOX.center.x;
           BODYBOX.y = BOX.center.y;
           printf("BodyCenter X: %d, BodyCenter Y: %d\n",BODYBOX.x,BODYBOX.y); 
          
           // anzeige TargetBox (yellow Rect)

           TARGETBOX.x1 = BCENTERX - 20; 
           TARGETBOX.y1 = BCENTERY - 20;  
           TARGETBOX.x2 = BCENTERX + 20; 
           TARGETBOX.y2 = BCENTERY + 20; 
           TARGETBOX.width  = 40;
           TARGETBOX.height = 40;

           cvRectangle( IMG_8UC3, cvPoint( TARGETBOX.x1,TARGETBOX.y1 ), cvPoint( TARGETBOX.x2, TARGETBOX.y2 ), cvScalar(0x00,0xff,0xff),8,-1); // cvScalar(255,255,255), 8, -1 );  
           
           BodyTrackCalc();
            
        } // end contour 2
      
     // original from cvColor     
     for( C = FIRST_CONTOUR; C !=NULL; C = C->h_next ) 
        { 
           cvWorkCounter++;
           
           cvCvtColor( IMG_8UC1, IMG_8UC3 , CV_GRAY2BGR );
           
           cvDrawContours( IMG_8UC3, C,
                           CVX_RED,  //Yarg, these are defined above, but not in the book.  Oops
                           CVX_BLUE,
                           0,        // Try different values of max_level, and see what happens
                           2,
                           8
                         );
           
           N++;
           printf("Contour #%d\n", N );
           
           // here das wichtige bild
           cvShowImage( "Contour", IMG_8UC3 );
        
           printf(" %d elements:\n", C->total );

           // das funzzt noch nicht richtig
           for(int II = 0; II <= C->total; ++II) 
              {
                 CvPoint* P = CV_GET_SEQ_ELEM( CvPoint, C, II );
                       
                 // here zuweisung bestcontour into points
                 XP = P->x; 
                 YP = P->y;
                             
                 PT1.x = XP;
                 PT1.y = YP;
                 PT2.x = XP;
                 PT2.y = YP; 

                 cvLine( RESULT1, PT1, PT2,CV_RGB(255,0,255),4 ,8 ); 
                 cvLine( RESULT1, PT1,PT2,CV_RGB(128,0,255),4 ,8 ); 
                              
              } // end ForLoop 
           
           N++;
             
        } // end   for( CvSeq* c=first_contour; c!=NULL; c=c->h_next ) 
      
     cvShowImage( "Contour", IMG_8UC3 );

     N = 0;
     printf("DONE\n");
     
  }
/*************************************************************************************************/
int colorDetections()
  {
     printf("ColorDetections\n");
       
     RESULT1 = cvCreateImage( cvGetSize( frame1 ), 8, 1 );
           
     HEIGHT = frame1->height;
     WIDTH = frame1->width;
           
     STEP = frame1->widthStep;
     CHANNELS = frame1->nChannels;
     DATA = (uchar *)frame1->imageData;
            
     //  Here I use the Suffix r to diffenrentiate the result data and the frame data
     //  Example :stepr denotes widthStep of the result IplImage and step is for frame IplImage
               
     STEPR = RESULT1->widthStep;
     CHANNELSR = RESULT1->nChannels;
           
     DATAR = (uchar *)RESULT1->imageData;
           
     for(I = 0;I < (HEIGHT); I++) 
        {
           for(J = 0;J <(WIDTH); J++)
              {
                 //  As I told you previously you need to select pixels which are
                 //  more red than any other color
                 //  Hence i select a difference of 29(which again depends on the scene).
                 //  (you need to select randomly and test
                      
                 if(((DATA[I * STEP + J * CHANNELS + 2]) > (29 + DATA[I * STEP + J *CHANNELS]))
                      && ((DATA[I * STEP + J * CHANNELS + 2]) > (29 + DATA[I * STEP + J * CHANNELS+1])))
                    {
                       DATAR[I * STEPR + J * CHANNELSR] = 255;
                    }
                 else
                    {
                       DATAR[I * STEPR + J * CHANNELSR] = 0;
                    }
              }
        }
  }
/*************************************************************************************************/
void ext_bodyTrack()
  {
     TEMP = 0;
     I = J = K = 0;
     
     // here colorDetections()-Function
     colorDetections();
  
     cvSaveImage("result.jpg",RESULT1);

     BodyContours();
  
  }
/*************************************************************************************************/ 
