//============================================================================================//
//    The RobotHeadSystem-Project                                                   
//    by                                                                    
//    Rytta Communications Inc.                                           
//    (c) Version 0.0207 March 2010                                      
//                                                                          
//===========================================================================================// 
//    headSensor0207.cpp        ( ex. serialPropDevBoard14.cpp, ex headSensor0101.cpp, ex SensorCommunications7.cpp ( exsensorRobotSerialComm11.cpp ( ex serialPropDevBoard12.cpp ))
//    ------------------        
//     
//    basics parsing communications204.cpp
//    
//    begin        : Thursday 11. March 10.15:00 GMT 2010                            
//    copyright    : (C) 2008/2010 by  s.morf 
//    email        : stevenmorf@bluewin.ch 
//    
//    compileScript: ./compileScript_87.sh 
//
//     as          : - Main: nomadHeadSystem0207.cpp  
//                   - Sub1: redBallTracking0207.cpp  
//                   - Sub2: servoTracking0207.cpp 
//                   - Sub3: headSensor0207.cpp
//                   - Sub4: bodyTracking0207.cpp
//                   - Sub5: simBehavior02067.cpp 
//                   - Sub6: audioWriter0207.cpp 
//                
//     run as      : ./nomadHeadSystem0207
// 
//    for: 
//    Basics of : Sensor - SerialCommunications with PropellerDevBoard
//                - ping Distance Sensor 
//                  - range_mm (original)
//                  - range_cm (optional)               
//    
//    EXPERIMENTAL and TESTBED
//    
//    with NomadHeadTestSystem_15.spin
//    
//***************************************************************************************************/ 
//     THIS PROGRAMM IS UNDER THE GNU-LICENCE                              
/****************************************************************************************************  
    This program is free software; you can redistribute it and/or modify    
it under the terms of the GNU General Public License as published by the Free
Software Foundation; either version 2 of the License, or (at your option) any
later version.                                                                
*************************************************************************************************
REFERENCES
 
 - 2) PING-DistanceMeter 
      - PIN 6 
        - 3 adrig
        - GND   white  ->                        blue 
        - +5v   black  ->                        green
        - Sig   red    ->  <1kohm-wstand (blue)> yellow

**************************************************************************************************
REFERENCES:
   1) Serial Com:
      - mit / ohne Webcams: usbPort = /dev/ttyUSB0
      - with
        - 9600 BAUD, no parity, 8 data-bits and 1 stop bit
          - gem. BS2 Controller-DokuBook page 159 und ff. with DEBUGIN (at BS2)

   1. unplug your cam 
   2. modprobe -r uvcvideo 
   3. modprobe -r snd_usb_audio 
   4. replug your cam    
***************************************************************************************************/ 
#include<iostream>

#include <math.h>

// C-Stuff for RS232
#include <stdio.h>
#include <stdlib.h>

#include <fcntl.h> 
#include <string.h> 
#include <ctype.h> 

#include <setjmp.h> 
#include <termios.h> 
#include <unistd.h> 
#include <sys/signal.h> 
#include <sys/types.h> 
#include <errno.h> 
#include "curses.h"      
#include <ctype.h>
#include <sys/io.h> 

#include <sys/stat.h>

#include <string.h>

#include <sstream>
 
using namespace std;
/************************************************************************************************/
#define _POSIX_SOURCE 1  	    // POSIX compliant source  

// new for communications 
#define BAUDRATE_PROP   B9600   // baudrate settings for commands mots                                 
#define MODEMDEVICE_PROP "/dev/ttyUSB0"  // on QUAD !! NO CHANGE IF 2 USBWEBCAMS ON USBPORTS 


#define MAXTOKLEN 255  // for tokenizer
#define BUFLEN 255
#define S_MAXTOKLEN 8

// new extern
extern struct termios oldtio,newtio, options; 

// ping
int range_mm;     // SensorInput 
double range_cm;  // (double) range_mm / 10;


/*************************************************************************************************/
// extern Vars
extern bool WANT_SENSOR_DATAS_KEYs;
extern int cnt_1;
extern bool comDone;

extern int fw_prop;     // w=write 
extern int fr_prop;     // r=read
extern int res;
extern int rescommand;
extern int s_len;

extern char combuf[255]; 
extern char buffer[BUFLEN];
extern char buf[255];
extern char s_buffer[BUFLEN];

extern int antw; // for output
extern char *sendDataStr;
extern char *recDataStr;

extern char sendData[12];    // for umwandlung int to string with sprintf
extern const char *sendEOF;  // = ("\r");
extern int n; 
extern int comDoneInt;

/************************************************************************************************* 
* Don't forget to give the appropriate serial ports the right permissions                        *
* (e. g.: chmod a+rw /dev/ttyS0)!                                                                *
* baudrate settings are defined in <asm/termbits.h>, which is                                    *       
* included by <termios.h>   ==  system(init_1);                                                  *  
**************************************************************************************************/ 
int sensorReader()
  {
     int stopRead = 5;
     
     // printf("Now in SensorReader\n");

     fr_prop = open(MODEMDEVICE_PROP, O_RDONLY | O_NOCTTY );
     if(fr_prop <0)
        {
           perror(MODEMDEVICE_PROP);
           printf("cannot open ttyUBS0");         
           exit(-1); 
        }
     
     tcgetattr(fr_prop,&oldtio);          // save current serial port settings 
     bzero(&newtio,sizeof(options));      // clear struct for new port settings 

     fcntl(fr_prop, F_SETFL,0);
     
     if(tcgetattr(fr_prop, &options) != 0) return(-1);

     cfsetspeed(&options,B9600); 
     /*setze Optionen */
     
     options.c_cflag &= ~PARENB;  // NO PARITYBIT
     options.c_cflag &= ~CSTOPB;  // 1 STOPPBIT
     options.c_cflag &= ~CSIZE;   // 8 DATENBIT 
     options.c_cflag |= CS8;
     options.c_cflag |= (CLOCAL | CREAD);  // CD-SIGNAL IGNORE
      
     options.c_lflag &= ~(ICANON | ECHO | ECHOE | ISIG);
     
     options.c_oflag &= ~OPOST;  // SETZE RAW-INPUT
     
     options.c_cc[VTIME]  = 10;    /* TIMEOUT 10 SEKUNDEN */ 
     options.c_cc[VMIN]  = 0;      /* wait auf min. 0 zeichen old blocking read  until 1 character arrives */ 
     
     // now clean the modem line and activate the settings for the port  
     tcflush(fr_prop, TCIFLUSH);
  
     if(tcsetattr(fr_prop,TCSAFLUSH, &options) != 0) return (-1); 

     //printf("Now Read\n");

     comDone = false;
     
     while( !comDone)
        {  
           res = read(fr_prop,buf,255);
           buf[res]=0;              /* set end of string, so we can printf */
           
           int i;
             
           // printf("In[%d]: %s\n",i,buf); // printf(":%s:%d\n", buf, res); 
           // printf("Res: %d\n",res);

           rescommand = res;

           printf("Input: %s\n",buf);
           // printf("Commr: %d\n",rescommand);

           range_mm = atoi(buf);
           printf("Ping_Range_mm: %d mm\n",range_mm);

           // new stuff 04.03.2010
           range_cm = (double)range_mm / 10.0;
           printf("Ping_Range_cm: %f cm\n",range_cm);


           comDoneInt = 5;  // 5 

           if(comDoneInt == stopRead)
              {
                 comDone = true;
                 
                 printf(" OK     \n");
                 break;
              }

        }

     /* restore the old port settings */
     tcsetattr(fr_prop,TCSANOW,&oldtio); 
     
     close(fr_prop);
     printf("SensorReader is Closed\n");

  }
/*************************************************************************************************/
int sensorSender()
  {
     //printf("Communications: SensorSender: %s\n",sendDataStr); 

     fw_prop = open(MODEMDEVICE_PROP, O_WRONLY | O_NOCTTY );        // old O_RDWR 
     if(fw_prop <0)
        {
           perror(MODEMDEVICE_PROP);
           printf("cannot open ttyUSB0");         
           
           exit(-1); 
        }
     tcgetattr(fw_prop,&oldtio);                // save current serial port settings 
     bzero(&newtio,sizeof(options));        // clear struct for new port settings 

     fcntl(fw_prop, F_SETFL,0);
     if(tcgetattr(fw_prop, &options) != 0) return(-1);
     cfsetspeed(&options,B9600); 
     /*setze Optionen */
      
     options.c_cflag &= ~PARENB;  // NO PARITYBIT
     options.c_cflag &= ~CSTOPB;  // 1 STOPPBIT
     options.c_cflag &= ~CSIZE;   // 8 DATENBIT 
     options.c_cflag |= CS8;
     options.c_cflag |= (CLOCAL | CREAD);  // CD-SIGNAL IGNORE
     // kein echo, keine steuerzeichen, keine interrupts
     
     options.c_lflag &= ~(ICANON | ECHO | ECHOE | ISIG);
     
     options.c_oflag &= ~OPOST;  // SETZE RAW-INPUT
     
     options.c_cc[VTIME]  = 10;    /* TIMEOUT 10 SEKUNDEN */ 
     options.c_cc[VMIN]  = 0;      /* wait auf min. 0 zeichen old blocking read  until 1 character arrives */ 
  
     // now clean the modem line and activate the settings for the port  
     tcflush(fw_prop, TCIFLUSH);
  
     if(tcsetattr(fw_prop,TCSAFLUSH, &options) != 0) return (-1); 
           
     // here new write to DevBoard
     write(fw_prop,sendDataStr,s_len);  // len: old 2
        
     /* restore the old port settings */
     
     tcsetattr(fw_prop,TCSANOW,&oldtio); 
     close(fw_prop);
     
     // printf("Sender is closed\n");
     // bool_SenderDone = false;
           
  } // end Sender  

/***************************************************************************************************/
void sensorSendData()        
  { 
     sensorSender();
     sensorReader();
  }

/*** sensorController ******************************************************************************/
int sensorControl()
  {
     printf("SensorControl\n");
     antw = 1; 
     // printf("Command: %d \n",antw);
                  
     n = sprintf (sendData, "%d ", antw);
     //printf ("[%s] is a %d char long string\n",sendData,n);
                   
     //printf("SendData: %s\n",sendData); 
          
     sendDataStr = (char *)malloc(strlen(sendData));  
     strcpy(sendDataStr,sendData); 
     s_len = strlen(sendEOF); 
     strncat(sendDataStr,sendEOF,s_len); 
                 
     s_len = strlen(sendDataStr); 
     // printf("S_Len: %d\n",s_len); 
     // printf("SendDataString: %s\n",sendDataStr);

     sensorSendData();
  }    

/*** servoController ******************************************************************************/
int ext_SensorCommunications()
  {
     // inputs : <1>  receive Datas
     if(WANT_SENSOR_DATAS_KEYs == true)   
        {
           sensorControl();
           
           WANT_SENSOR_DATAS_KEYs = false;      
        } 
  }    
/**************************************************************************************************/
