//============================================================================================//
//    The Nomad-Head-System-Project                                                   
//    by                                                                    
//    Rytta Communications Inc.                                           
//    (c) Version 0.207. March  2010 
//
//    BASICS EXPERIMENTAL -> TESTING NEW CONCEPTS -> autonomeBehavior (2)                                      
//    only OpenCV & SerialCom     
//    for NomadHeadSystem with Winglets                                                                
//    and Audio with Festival
//===========================================================================================// 
//     nomadHeadSystem0207.cpp  
//     ------------------------    
//     
//     begin     : Thursday 11. March  10.15:00 GMT 2010                            
//     copyright : (C) 2008/2009/2010 by  s.morf 
//     email     : stevenmorf@bluewin.ch 
//     originalCompile with   
//     opencv & pthreads:  
//     g++ -I/usr/local/include/opencv -L /usr/local/lib -lcxcore -lcv -lhighgui -lcvaux -lml -o NomadHeadSystem011 NomadHeadSystem011 -lm -lpthread

//     compileScript: ./compileScript_87.sh 
//
//     as           : - Main: nomadHeadSystem0207.cpp  
//                    - Sub1: redBallTracking0207.cpp  
//                    - Sub2: servoTracking0207.cpp 
//                    - Sub3: headSensor0207.cpp
//                    - Sub4; bodyTracking0207.cpp  
//                    - Sub5: simBehavior0207.cpp    
//                    - Sub6: audioWriter0207.cpp     
//     
//     run as    : ./nomadHeadSystem0207
//             
//                
//    for: 
//    Basics of : - ComputerVisions with 2 USB-WebCams as Eyes
//                  - with (pthreads options)
//                  - OpenCV 
//                    - 2 x WebCams
//                  - comControl with  
//                    - SerialControl of CamHeadSystem via PropDevBoard
//                      - 3 DOF (Nick & Turn & opt.Roll)
//                      - horizontal Turns of CamServos  
//                  - comControl of Winglets-MicroServos 2x   
//                  - Audio-Behavior with laptop (RS232) and FESTIVAL
//   PROGRAMMS:
//   - Quad:
//     - nomadHeadSystem0207.cpp 
//   - XP:
//     - PropellerParallax-IDE: PropellerDevelopmentBoard (Servos + PING)
//       - NomadHeadTestSystem_15.spin
//         - incl. Winglets-Servo Unterstuetzung
//         - HeadSensor (PING-DistanceMeter))
//         - incl. 2xBlueLeds         
//
/*************************************************************************************************
References:

  Copyright (C) 2007 Julian Oliver
  http://julianoliver.com

  Modifications
  Copyright (C) 2008 Jean-Philippe Deblonde
  http://www.lifl.fr/~deblonde/

  verwendete programme:
  from /root/Desktop/OPENCV/opencv-tutorial.pdf (german)
  <Bildverarbeitung mit OpenCV, author Johannes Wienke, Uni Bielefeld 2008>

  OpenCV_Beispiele From RoboWeb
  Mehrere Bilder in einem Fenster
  from http://opencvlibrary.sourceforge.net/DisplayManyImages.

  Display video from webcam

  lucasKanadeAlgorithmus: from
  cvLkDemo1.cpp from samples/c/ (lkdemo.c -> erkennt face (frontal)
  lkdemo.c from book "learning opencv" /samples/c/
  if <r> automatical Init
  "Learning OpenCV-Book"
 
  Author  Nash
  License GPL
  Website http:/nashruddin.com

  OpticalFlow from
  David Stavens
  Standford Artificial Intelligence Lab (PDF)

  3d distance tracking using head width
  name: headtracking1.cpp
  from:http://code.google.com/p/ehci/wiki/HeadTracking
 
  Ref: This code uses some approximations, but is a good starting point

//************************************************************************************************/ 
//     THIS PROGRAMM IS UNDER THE GNU-LICENCE                              
/*************************************************************************************************  
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*************************************************************************************************/ 
// Sample Application to demonstrate how Face detection can be done as a part of your source code.
// as *.cpp source
// Grabbing Images from two cameras simultaneously
// Note: Here we are using USB cameras 
/*************************************************************************************************
NOTES:
02.03. - 1.OnlineTest nach Umbauten mit neuer PinBelegung
       - RUN OK

pin-Belegungen:
- CamServo0  -> P0
- RollServo1 -> P1
- NickServo2 -> P2
- TurnServo3 -> P3
- WingServo  -> P4

- PING       -> P6

- LED 14     -> P7
- LED 15     -> P8   

 - CamServo0: PIN 0
   - Center: 1_500  -> 11_500  OK   
   - Left  : 1_250  -> 11_250  OK           
   - Right : 1_750  -> 11_750  OK           

 - RollServo1: PIN 1                            
   - Center: 1_660  -> 21_660  OK     
   - Left  : 1_700  -> 21_700  OK    
   - Right : 1_620  -> 21_620  OK 
          
 - NickServo2: PIN 2
   - Center: 1_400  -> 31_400 OK 
   - UP    : 1_600  -> 31_600 OK            
   - Down  : 1_300  -> 31_300 OK            
     
 - TurnServo3: PIN 3
   - Center: 1_400  -> 41_400  OK   
   - Left  : 1_000  -> 41_000  OK ca  45 deg  
   - Right : 1_800  -> 41_800  OK ca  45 deg    
     
 - WingLetsServo  PIN 4             
   - Center                  : 1_300   -> 51_300
   - WingLets Anheben max.UP : 1_950   -> 51_950   max.Right 2_000  
   - WingLets Senken min.Down: 1_300   -> 51_300   min.Left  1_000                    


----------------------------------------------------------------------------------------------------
- HeadSensor -> PING
  Pin 6 
  Output: range_mm
----------------------------------------------------------------------------------------------------

Tracking: 
- mal testen welche bewegungen der kopf machen muesste um ein statisches Ziel
  in die BildMitte zubekommen
  --> Der Ball wurde immer in aeussersten Ecken plaziert 
      - 1) untenRechts:  pos ca 600,400
           1) - Down      = 31_350
           2) - TurnRight = 41_480
      - 2) untenLinks:   pos ca 100,400
           1) - Down      = 31_350
           2) - TurnLeft  = 41_220
      - 3) obenLinks:    pos ca 100,100 
           1) - UP        = 31_480
           2) - TurnLeft  = 41_220
      - 4) obenRechts:   pos ca 600,100
           1) - UP        = 31_500
                - TurnRight = 41_400    

/*************************************************************************************************
NOTES: DD. 02.03.2010
REFERENCES FOR SERVO-MOVEMENTS AFTER NEW PIN-BELEGUNG:
------------------------------------------------------
Pin-Belegungen:
- CamServo0  -> P0
- RollServo1 -> P1
- NickServo2 -> P2
- TurnServo3 -> P3
- WingServo  -> P4

 - CamServo0: PIN 0
   - Center: 1_500  -> 11_500  OK   
   - Left  : 1_250  -> 11_250  OK           
   - Right : 1_750  -> 11_750  OK           

 - RollServo1: PIN 1                            
   - Center: 1_660  -> 21_660  OK     
   - Left  : 1_700  -> 21_700  OK    
   - Right : 1_620  -> 21_620  OK 
          
 - NickServo2: PIN 2
   - Center: 1_400  -> 31_400 OK 
   - UP    : 1_600  -> 31_600 OK            
   - Down  : 1_300  -> 31_300 OK            
     
 - TurnServo3: PIN 3
   - Center: 1_400  -> 41_400  OK   
   - Left  : 1_000  -> 41_000  OK ca  45 deg  
   - Right : 1_800  -> 41_800  OK ca  45 deg    
     
 - WingLetsServo  PIN 4             
   - Center                  : 1_300   -> 51_300
   - WingLets Anheben max.UP : 1_950   -> 51_950   max.Right 2_000  
   - WingLets Senken min.Down: 1_300   -> 51_300   min.Left  1_000                    
----------------------------------------------------------------------------------------------------
 
SPIN PROG LOOK AT newProgSpin_2010


*************************************************************************************************/
#include<iostream>

#include "cvGlobalSystem.h"

#include <math.h>

// C-Stuff for RS232
#include <stdio.h>
#include <stdlib.h>

#include <fcntl.h> 
#include <string.h> 
#include <ctype.h> 

#include <setjmp.h> 
#include <termios.h> 
#include <unistd.h> 
#include <sys/signal.h> 
#include <sys/types.h> 
#include <errno.h> 
#include "curses.h"      
#include <ctype.h>
#include <sys/io.h> 

#include <sys/stat.h>

#include <string.h>

#include <sstream>

#include <X11/Xlib.h>
#include <X11/extensions/XTest.h>
 
using namespace std; 
/***************************************************************************************************/
//Some defines we left out of the book
#define CVX_RED	CV_RGB(0xff,0x00,0x00)
#define CVX_GREEN	CV_RGB(0x00,0xff,0x00)
#define CVX_BLUE	CV_RGB(0x00,0x00,0xff)

bool quit;
bool done;

// ServoKeys Global
bool CAMSERVO_LEFT_KEY1;
bool CAMSERVO_RIGHT_KEY2;
bool ROLLSERVO_LEFT_KEY3;
bool ROLLSERVO_RIGHT_KEY4;
bool NICKSERVO_UP_KEY5;
bool NICKSERVO_DOWN_KEY6;
bool TURNSERVO_LEFT_KEY7;
bool TURNSERVO_RIGHT_KEY8;
bool CENTER_SERVOS_100_KEYc;
bool CENTER_SERVOS_100;
bool WANT_SENSOR_DATAS_KEYs;

bool RED_TRACK_KEYt;
bool AUTO_COLORSLIDE_KEYa;
bool STOP_COLORSLIDE_KEYq;

bool RED_BALL_TRACK;
bool HEAD_TRACK;
bool BACK_GROUND_TRACK;
bool WINDOW_TRACK;

bool LEARNING;

// opencv stuff
CvCapture *capture1 = 0;
CvCapture *capture2 = 0;
IplImage  *frame1 = 0;
IplImage  *frame2 = 0;

// behavior image // black.jpg for window
IplImage  *simImage = 0;  //  cvZero( simImage );
IplImage* temp1; 

// for textOutput HandGesture
CvFont font;

// opencv Groesse-Frames-Windows 640 x 480
int x = 640;  
int y = 480;  
int key = 0;
 
// Muss so sein, sonst fehler bei system(init_1);
// in main -> for ServoCommunications
const char *init_1 = "chmod a+rw /dev/ttyUSB0";    // for Servos PropBoard
const char *init_2 = "chmod a+rw /dev/ttyS0";      // for LinuxLaptop rs(232) and FESTIVAL

int trackClick = 0;
int blueBodyClick = 0;

#define WIDTH  640
#define HEIGHT 480

#define SEARCHRANGE 100

#define STATE_UP   0
#define STATE_DOWN 1

#define CHANGE_NONE 0
#define CHANGE_SHRINKING 1
#define CHANGE_GROWING 2

#define CHANGEFACTOR .75

//#define MAX(a,b) (((a) > (b)) ? (a) : (b))
//#define MIN(a,b) (((a) < (b)) ? (a) : (b))

// mouseBoxStuff
CvRect mouseBox;
bool drawing_mouseBox = false;

bool initHeadTrack;

// Behavior + Winglets Move
double X0;         // = StartWert0
int intX0;         // = for Winglets 
double Xf0;        // EndPosY 
int intXf0;        // endPoint slider
double weight0;    // gewichtungen 
int intWeight0;

// Calculations Behavior:
double behavior;
// old
// double factor = 650.0; // diff 51_950 (maxUp) - base
double factor = 0.0041667;  // 1.0 / 240
int step = 0;
int oldstep;

int states;
int onWindow = 0;
int onBackGround = 0;
extern int onHead;
extern int onRedBall;

const char *texte0 = "                          ";
const char *texte1 = "Red-Ball  Detections is On";
const char *texte2 = "Head-Body Detections is On";
const char *texte4 = "SimBehavior Running       ";
const char *texte5 = "Restart Applications      ";

int simCnt = 0;

/**************************************************************************************************/
// externe functionen
// from ServoCommunications0202.cpp
void ext_setServoValuesCenter();
void ext_SerialServoControl();
int ext_specialSingleServoCenterControl(int antw);
int servoControl();

// from headSensor0202.cpp
void ext_SensorCommunications(); 

// from colorTracking0202.cpp
//void ext_red_paint();      
void ext_RedTracking();
void Behavior();

// from bodyTracking0204.cpp
void ext_bodyTrack();

// from simBehavior0205.cpp
void ext_simBehavior();

// from simBehavior0206E.cpp
int mimikryNick();
int mimikryRoll();
void ext_simStateMachine();

// from audioWriter0207.cpp
void ext_audioWrite(int antw);

/*************************************************************************************************/
// externe vars
extern int camx, camy;
extern int centerx, centery;
extern int antw;

extern int CamServo0;
extern int RollServo1;  
extern int NickServo2;  
extern int TurnServo3;
extern int WingServo;
  
extern int newCamServo;
extern int newRollServo;
extern int newNickServo; 
extern int newTurnServo;
extern int newWingServo;

extern int TrackClick; 
extern int rc,gc,bc;

extern int onHead;
extern int onRedBall;

// for neuralNet
extern double W_31;
extern double W_32; 

// delay (nnn)
void delay(long millisek);

/*************************************************************************************************/
void on_mouse( int event, int x, int y, int flags, void* param )
  {

  }
/**************************************************************************************************/
void KeyMenue()
  {
     printf("KeyMenue\n");
     printf("Key < q > = System Restart\n");
     printf("Key < c > = Center All Servos\n");
     printf("Key < ESC > = EXIT\n");
  } 
/*************************************************************************************************/ 
int main()
  {
     CENTER_SERVOS_100_KEYc = false;
     WANT_SENSOR_DATAS_KEYs = false;
     RED_TRACK_KEYt         = false;
     RED_BALL_TRACK         = false;  
     HEAD_TRACK             = false;    
     AUTO_COLORSLIDE_KEYa   = false;
     STOP_COLORSLIDE_KEYq   = false;
     BACK_GROUND_TRACK      = false;
     WINDOW_TRACK           = false;  
     LEARNING               = false;

     trackClick = 0; 
     initHeadTrack = true; 
            
     quit = false;
     done = false;
     
     centerx = 320;
     centery = 240;
     
     camx = centerx;
     camy = centery;

     // stuff for Behavior with yellowPoint for simBehavior0206E1.cpp
     weight0 = 50.0;     
     X0      = 240.0;  // = StartWert1 Y-dir
     Xf0     = 10.0;   // EndPosY      Y

     W_31 = 0.7;  // teile neuralNet calc in redBallTracking
     W_32 = 0.5;

     step = 0;         // stepping for states   
     
     // from RedTrack
     Display *dpy = XOpenDisplay (0); 
     mouseBox = cvRect( -1, -1, 0, 0 );
     
     // init usb as Servos PropBoard /dev/ttyUSB0 -> init_1 =  "chmod a+rw /dev/ttyUSB0";  
     system(init_1); 

     // init rs232 for com to laptop /dev/ttyS0 -> init_2 =  "chmod a+rw /dev/ttyS0";  
     system(init_2); 

     // !!!!! TESTEN OB NOTWENDIG 
     // hat keinen negativen einfluss
     // from SerialCommunications1.cpp
     ext_setServoValuesCenter(); 

     // audioWriter with < 1 > hello i am Nomad
     ext_audioWrite( 1 ); // (int antw)

     capture1 = cvCaptureFromCAM(0);
     capture2 = cvCaptureFromCAM(1);

     // WebCAM 1 frame width,height 320x240 == OK
     cvSetCaptureProperty(capture1, CV_CAP_PROP_FRAME_WIDTH, x);
     cvSetCaptureProperty(capture1, CV_CAP_PROP_FRAME_HEIGHT, y);

     // WebCAM 2 frame width,height 320x240 == OK
     cvSetCaptureProperty(capture2, CV_CAP_PROP_FRAME_WIDTH, x);
     cvSetCaptureProperty(capture2, CV_CAP_PROP_FRAME_HEIGHT, y);
  
     if( !capture1 )
        {
           printf( "Cannot open initialize WebCam 1\n" );
           return 1;
        }
     if( !capture2 )
        {
           printf( "Cannot open initialize WebCam 2\n" );
           return 1;
        }

     // create a window
     cvNamedWindow("Left", CV_WINDOW_AUTOSIZE); 
     cvMoveWindow("Left", 0, 0);
     
     cvNamedWindow("Right", CV_WINDOW_AUTOSIZE); 
     cvMoveWindow("Right", 640, 0 );
      
     cvNamedWindow("Contour",CV_WINDOW_AUTOSIZE);
     cvMoveWindow("Contour", 0, 480 );

     trackClick = 1;   
     
     // initHeadGestures 
     initHeadTrack = true;
         
     // for Text on screen for HandGestures
     cvInitFont(&font, CV_FONT_HERSHEY_SIMPLEX, 1.0, 1.0, 0, 1, CV_AA);

     frame1 = cvQueryFrame( capture1 );
     int step = frame1->widthStep / sizeof (uchar);
     temp1 = cvCloneImage ( frame1 ); 
     
     // now into While-Loop
     while(!done)
        {
           // get a frame 
           frame1 = cvQueryFrame( capture1 ); // left bodytrack
           frame2 = cvQueryFrame( capture2 ); // right redtrack

           //cvRedGloves
           int step = frame2->widthStep / sizeof (uchar);

           // always check 
           if( !frame1 ) break;
           if( !frame2 ) break;

           cvCopyImage( frame1, temp1 );

           // new SimBehavior0205.cpp
           if( simCnt == 0 ) 
              {
                 cvPutText (frame2, texte0 ,cvPoint(100,400), &font, cvScalar(255,255,0)); 
                 cvPutText (frame2, texte4,cvPoint(100,400), &font, cvScalar(255,255,0)); 
                 
                 ext_simBehavior();
              }  
           
           // automatical Switch into AutoColorSide no key <a>
           if( AUTO_COLORSLIDE_KEYa == true )    
              {
                 simCnt = 1; 

                 cvPutText (frame2, texte0, cvPoint(100,400), &font, cvScalar(255,255,0)); 
                 
                 // Behavior();
                       
                 // RedBallDetections             
                 ext_RedTracking();

                 if(RED_BALL_TRACK == true)
                    {
                       cvPutText (frame2, texte0 ,cvPoint(100,400), &font, cvScalar(255,255,0)); 
                       cvPutText (frame2, texte1 ,cvPoint(100,400), &font, cvScalar(255,255,0)); 
                       
                       // Behavior();
    
                       mimikryNick();
                       onRedBall = 2;
                       onHead    = 1;
                    } 

                 printf("\n\n(3) RED_BALL_TRACK == %d\n\n",RED_BALL_TRACK);

                 if(RED_BALL_TRACK == false)
                    {
                       cvPutText (frame2, texte0 ,cvPoint(100,400), &font, cvScalar(255,255,0)); 
                       cvPutText (frame2, texte2 ,cvPoint(100,400), &font, cvScalar(255,255,0)); 
                        
                       // Behavior();
                       
                       // new Head & Hand-Detections
                       ext_bodyTrack();

                       mimikryRoll();
                       onRedBall = 1;
                       onHead = 2;
                    }  

                 // ex if(CENTER_SERVOS_100_KEYc == true) INNERHALB NOK 02.03.2010
                             
                 // standallone for winglets
                 Behavior();
                  
                 CamServo0  = newCamServo; 
                 RollServo1 = newRollServo;  
                 NickServo2 = newNickServo;   
                 TurnServo3 = newTurnServo;
                 WingServo  = newWingServo; 

              } // end // automatical Switch into AutoColorSlider no key <a>  

           // ausserhalb OK 
           if(CENTER_SERVOS_100_KEYc == true)
              {
                 printf("Key < c > CenterAllServos\n");  
                 onRedBall = 2; // for mimikry Nick 
                 onHead    = 2; // for mimikry Roll

                 ext_SerialServoControl();            
                 CENTER_SERVOS_100_KEYc = false;
              } 

           // new 07.03. here extern einbauen
           Behavior(); 
          
           // display current frame 
           cvShowImage( "Left", frame1 );
           cvShowImage( "Right", frame2 );
           
           cvSaveImage( "leftImage.jpg", frame1  );
           cvSaveImage( "rightImage.jpg", frame2 ); 
            
           key = cvWaitKey(10)& 0xFF; 

           if(key==27) // ESC 
              {
                 done = true;
                 quit = true;

                 // Exit Laptop + Sound EXIT
                 ext_audioWrite( 5 );   // (int antw);
                 delay(1000);           // wait for song
                 // EXIT Laptop audioReader11.cpp
                 ext_audioWrite( 10 );  // (int antw); 

                 ext_SerialServoControl();

                 break;
              }
            
           switch(key)
              {
                 case 's':
                    WANT_SENSOR_DATAS_KEYs = true;  
                    printf("Key < s > = HeadSensorDatas\n"); 
                    ext_SensorCommunications();                                  
                 break;
                 case 'c':
                    CENTER_SERVOS_100_KEYc = true;
                    printf("Key < c > CenterAllServos\n");  
                 break;        
                 case 'q':
                    printf("Key < q > = Restart Applications\n");
                    AUTO_COLORSLIDE_KEYa = false;
                    //   STOP_COLORSLIDE_KEYq = true;

                    RED_BALL_TRACK = false;
                    HEAD_TRACK     = false;
                    BACK_GROUND_TRACK = false;
                    WINDOW_TRACK = false;

                    rc = NULL;
                    gc = NULL;
                    bc = NULL;

                    simCnt = 0; 
                    cvPutText (frame2, texte0 , cvPoint(100,400), &font, cvScalar(255,255,0)); 
                    cvPutText (frame2, texte5 , cvPoint(100,400), &font, cvScalar(255,255,0)); 

                    onRedBall = 0;
                    onHead    = 0;
                     
                    // new Stuff 0206E1
                    weight0 = 50.0;     
                    X0      = 240.0;  // = StartWert1 Y-dir
                    Xf0     = 10.0;  

                    Behavior();

                    // center allServos
                    CENTER_SERVOS_100_KEYc = true;
                    
                    ext_SerialServoControl();

                    CamServo0  = newCamServo; 
                    RollServo1 = newRollServo;  
                    NickServo2 = newNickServo;   
                    TurnServo3 = newTurnServo;
                    WingServo  = newWingServo; 
                 break;  
                 case 'm':
                    KeyMenue();
                 break;

              } // end switch Key  
     
           // einsprung to ServoCommunications()
           // ext_SerialServoControl();
            
           if(done == true)
              {
                 cvWaitKey(0);

                 // free memory 
                 cvDestroyWindow( "Left" );
                 cvDestroyWindow( "cvBehavior" );
                 cvReleaseCapture( &capture1 );
                 cvDestroyWindow( "Right" );
                 cvReleaseCapture( &capture2 );
                 cvDestroyWindow("Result");
                 
                 cvDestroyAllWindows();
              }
        }  // end While

     // wait for a key
     cvWaitKey(0);
     
     //Release the image
     cvReleaseCapture(&capture1);
     cvReleaseCapture(&capture2);
     
     return 0;
 
  }
/***************************************************************************************************/ 
