//============================================================================================//
//    The Nomad-Head-System-Project                                                   
//    by                                                                    
//    Rytta Communications Inc.                                           
//    (c) Version 0.0207. March 2010 
//
//    EXPERIMENTAL -> TESTING NEW CONCEPTS                                       
//    Stripping OpenGL only OpenCV & SerialCom     
//    for NomadHeadSystem with Winglets 
//                                                          
//===========================================================================================// 
//     redBallTracking0207.cpp 
//     -----------------------    
//     
//     begin     : Thursday 11. March 10.15:00 GMT 2010                            
//     copyright : (C) 2008/2010 by  s.morf 
//     email     : stevenmorf@bluewin.ch 
//     compile with   
//     opencv & pthreads:  
//     g++ -I/usr/local/include/opencv -L /usr/local/lib -lcxcore -lcv -lhighgui -lcvaux -lml -o cvRedTrack2 cvRedTrack2.cpp -lm -lpthread
//
//     compileScript: ./compileScript_87.sh 
//
//     as           : - Main: nomadHeadSystem0207.cpp  
//                    - Sub1: redBallTracking0207.cpp  
//                    - Sub2: servoTracking0207.cpp 
//                    - Sub3: headSensor0207.cpp
//                    - Sub4; bodyTracking0207.cpp  
//                    - Sub5: simBehavior0207.cpp    
//                    - Sub6: audioWriter0207.cpp     
//     
//     run as    : ./nomadHeadSystem0207
//
//    for: 
//    Basics of : - ComputerVisions with 2 USB-WebCams as Eyes
//                  - with (pthreads options)
//                  - OpenCV 
//                    - 2 x WebCams
//                  - comControl with  
//                    - SerialControl of CamHeadSystem via PropDevBoard
//                      - 3 DOF (Nick & Turn & opt.Roll)
//                      - horizontal Turns of CamServos                
//                  - 2 x Winglets with 2 microServos
//                  - Audio with Laptop and FESTIVAL
//
/*************************************************************************************************
References:

  Copyright (C) 2007 Julian Oliver
  http://julianoliver.com

  Modifications
  Copyright (C) 2008 Jean-Philippe Deblonde
  http://www.lifl.fr/~deblonde/

  verwendete programme:
  from /root/Desktop/OPENCV/opencv-tutorial.pdf (german)
  <Bildverarbeitung mit OpenCV, author Johannes Wienke, Uni Bielefeld 2008>

  OpenCV_Beispiele From RoboWeb
  Mehrere Bilder in einem Fenster
  from http://opencvlibrary.sourceforge.net/DisplayManyImages.

  Display video from webcam

  lucasKanadeAlgorithmus: from
  cvLkDemo1.cpp from samples/c/ (lkdemo.c -> erkennt face (frontal)
  lkdemo.c from book "learning opencv" /samples/c/
  if <r> automatical Init
  "Learning OpenCV-Book"
 
  Author  Nash
  License GPL
  Website http:/nashruddin.com

  OpticalFlow from
  David Stavens
  Standford Artificial Intelligence Lab (PDF)

  3d distance tracking using head width
  name: headtracking1.cpp
  from:http://code.google.com/p/ehci/wiki/HeadTracking
 
  Ref: This code uses some approximations, but is a good starting point

//************************************************************************************************/ 
//     THIS PROGRAMM IS UNDER THE GNU-LICENCE                              
/*************************************************************************************************  
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*************************************************************************************************/ 
// Sample Application to demonstrate how Face detection can be done as a part of your source code.
// as *.cpp source
// Grabbing Images from two cameras simultaneously
// Note: Here we are using USB cameras 
/*************************************************************************************************
References: Winglets

       - RUN OK
         - Behavior: 0.958341
         - WingServoUp: 51922.921650
         - WingServo: 51923
         - ServoAntw: 51923
         - ServoTrackControl
         - SendDataString: 51923
         - Reader OK

/*************************************************************************************************/
#include<iostream>

#include <math.h>

#include "cvGlobalSystem.h"
 
// C-Stuff for RS232
#include <stdio.h>
#include <stdlib.h>

#include <fcntl.h> 
#include <string.h> 
#include <ctype.h> 

#include <setjmp.h> 
#include <termios.h> 
#include <unistd.h> 
#include <sys/signal.h> 
#include <sys/types.h> 
#include <errno.h> 
#include "curses.h"      
#include <ctype.h>
#include <sys/io.h> 

#include <sys/stat.h>

#include <string.h>

#include <sstream>
 
using namespace std; 
/***************************************************************************************************/
#define WIDTH  640
#define HEIGHT 480

#define SEARCHRANGE 100

#define STATE_UP   0
#define STATE_DOWN 1

#define CHANGE_NONE 0
#define CHANGE_SHRINKING 1
#define CHANGE_GROWING 2

#define CHANGEFACTOR .75

// cvRedGloves
//Some defines we left out of the book
#define CVX_RED   CV_RGB(0xff,0x00,0x00)
#define CVX_GREEN CV_RGB(0x00,0xff,0x00)
#define CVX_BLUE  CV_RGB(0x00,0x00,0xff)

//#define MAX(a,b) (((a) > (b)) ? (a) : (b))
//#define MIN(a,b) (((a) < (b)) ? (a) : (b))

int shapechange = CHANGE_NONE;

CvPoint topleft;
CvPoint bottomright;

// from cvRedGloves10.cpp
int xp,yp;
CvPoint pt1,pt2;
CvPoint* pt[2];

// from RedTrack
Display *dpy = XOpenDisplay (0); 
 
int searchx = -1;
int searchy = -1;

int startw = 100;
int starth = 100;

int lasth = 100;
int lastw = 100;

int lastheight = lasth;

int state;

// for RedTrack
static const double pi = 3.14159265358979323846;

bool trackInit = false;//
bool obenlinks = false;
bool obenrechts = false;
bool untenrechts = false;
bool untenlinks = false;

bool boolTarget = false;   

struct points
{
     int x;
     int y;
} Box;  

bool boolSetPoints = false;  

int centerx = 320;
int centery = 240;

int camx,camy;

int camStep  = 0;
int rollStep = 0;
int turnStep = 0;
int nickStep = 0; 

bool boxDoneOLx = false;
bool boxDoneOLy = false;
bool boxDoneULx = false;
bool boxDoneULy = false;
bool boxDoneORx = false;
bool boxDoneORy = false;
bool boxDoneURx = false;
bool boxDoneURy = false;
bool boxDonex   = false;
bool boxDoney   = false;

// winglets
double wingBase = 51300.0;

double wingStep;
double wingServoUp;
double wingServoDown;
int wingServoCenter = 51300;
int wingServo; // = antw; for servoTracking0201

// for neuralNet in simBehavior0206E1.cpp
// dd. 08.03.2010
// this for redBallStateMachine()
extern double W_31;
extern double W_32; 

double max_range_cm = 325.0;
double min_range_cm =   5.0;
double w_pingFac = 0.0028985;
 
/*************************************************************************************************/
// extern Vars
extern int CamServo0;   // = 11500;  
extern int RollServo1;  // = 21660;  new Head guckt geradeaus  old: 21_660 
extern int NickServo2;  // = 31340;  new Head guckt geradeaus mit Schale  Kinn on whiteBlock old: 31400;  
extern int TurnServo3;  // = 41400; 
extern int WingServo;   // = 51300;
 
extern int centerAllServos;
extern int centerCamServo0;
extern int centerRollServo1;
extern int centerNickServo2;
extern int centerTurnServo3;   
extern int centerWingServo;

extern int newCamServo;
extern int newRollServo;
extern int newNickServo;
extern int newTurnServo;
extern int newWingServo;
extern int antw;  // = 0;

extern IplImage *frame1;
extern IplImage *frame2;
// behavior
extern IplImage *simImage;

extern bool RED_TRACK_KEYt;

extern bool RED_BALL_TRACK;
extern bool HEAD_TRACK; 
extern bool BACK_GROUND_TRACK;
extern bool WINDOW_TRACK;
extern bool LEARNING;

extern int camClick;
extern int rollClick;
extern int nickClick;

// MIN/MAX - ServoValues
// - CamServo:
extern int minLeftCamServo;     
extern int maxRightCamServo;  
// - RollServo:
extern int maxLeftRollServo;   
extern int minRightRollServo;  
// - NickServo:
extern int maxUpNickServo;     
extern int minDownNickServo;   
// - TurnServo:
extern int minLeftTurnServo;   
extern int maxRightTurnServo;    
// - WingServo:
extern int minLeftWingServo;   
extern int maxRightWingServo; 

extern int trackClick;

// behavior Erease In/out
extern int ii;  // x-dir Direction Line

// Behavior + Winglets Move

extern int states;// Behavior + Winglets Move

extern double X0;         // = StartWert0
extern int intX0;         // = for Winglets 
extern double Xf0;        // EndPosY 
extern int intXf0;        // endPoint slider
extern double weight0;    // gewichtungen 
extern int intWeight0;

// Calculations Behavior:
extern double behavior;
extern double factor;   // 0.0034482;  // 1.0 / 240
extern double normal;   //  = 240.0;
extern int step;
extern int oldstep;

extern int onHead;
extern int onRedBall;

// ping
extern int range_mm;     // SensorInput 
extern double range_cm;  // (double) range_mm / 10;

extern bool WANT_SENSOR_DATAS_KEYs; //  redBallStateMachine()

int hInteressed; 
int rbInteressed;
   
/*************************************************************************************************/
// extern Functions
int ext_servoTrackControl();
// new from simBehavior - Mimikry 
int mimikryNick();
// from headSenor0206E.cpp
int ext_SensorCommunications();

// from simBehavior0206E
void Behavior();
// from simBehavior0206E
int mimikryAngryNick();
int mimikryFearPoseLeft();

// from audioWriter0207.cpp
void ext_audioWrite( int antw );
/*************************************************************************************************/ 

template<class T> class Image 
{
  private:
     IplImage *imgp;

  public:
     Image (IplImage *img=0) {imgp = img;}
     ~Image () {imgp = 0;}
     void operator=(IplImage *img) {imgp=img;}
     inline T* operator[] (const int rowIndex) 
{
           return ((T*)(imgp->imageData + rowIndex*imgp->widthStep));
}
};
/**************************************************************************************************/
typedef struct 
{
     unsigned char b,g,r;

} RgbPixel;

typedef struct 
{
     float b,g,r;
} RgbPixelFloat;

typedef Image<RgbPixel> RgbImage;

/**************************************************************************************************/
// playing with Ball dd. 04.03.2010
int RedTrackServo()   
  {
     printf("RedTrackServo-Functions\n");
       
     // testen of left or right
     if((obenlinks == true) || (untenlinks == true))
        { 
           if(obenlinks == true) 
              {
                 // TurnStep
                 turnStep = 20; 
                 newTurnServo = TurnServo3 - turnStep;
                            
                 antw = newTurnServo;   
                 ext_servoTrackControl();

                 printf("ObenLinks\n");                  
                 //printf("Box.x: %d, CamX: %d\n",Box.x,camx); 
                 //printf("RedBox: OBENLINKS NewTurnServo: %d , TurnServo3: %d \n",newTurnServo,TurnServo3);
                      
                 // new genauer old 300/340 new 310/330
                 if((Box.x > 310 ) && (Box.x < 330))  
                    {
                       boxDoneOLx = true;
                       printf("BoxTrack_X Done\n");
                    }   
                  
                 // NICKSERVO
                 nickStep = 20; 
                 newNickServo = NickServo2 + nickStep; 
                 
                 antw = newNickServo;
                 ext_servoTrackControl();      
                 
                 //printf("BoxBox.y: %d , CamY: %d\n",Box.y,camy); 
                 //printf("Box: OBENLINKS NewNickServo: %d , NickServo2: %d\n",newNickServo,NickServo2);
                 
                 // new genauer old 220/260 new 230/250
                 if((Box.y > 230 ) && (Box.y < 250))  
                    {
                       boxDoneOLy = true;
                       printf("BoxTrack_Y Done\n");
                    }           
                 
                 if((boxDoneOLx == true) && (boxDoneOLy == true))
                    {
                       printf(" All Done\n");
                            
                       // new Stuff
                       goto endFunc;
                    }
              }
           if(untenlinks == true) 
              {
                 // Turnstep
                 turnStep = 20;
                 newTurnServo = TurnServo3 - turnStep;
                 
                 antw = newTurnServo;   
                 ext_servoTrackControl();
          
                 printf("UntenLinks\n");
                 //printf("Box.x: %d, CamX: %d\n",Box.x,camx); 
                 //printf("Box: UNTENLINKS NewTurnServo: %d , TurnServo3: %d \n",newTurnServo,TurnServo3);
             
                 if((Box.x > 310 ) && (Box.x < 330))  
                    {
                       boxDoneULx = true;
                       printf("BoxTrack_X Done\n");
                    }   
                 
                 // NICKSERVO
                 nickStep = 20;
                 newNickServo = NickServo2 - nickStep;    
                       
                 // Abfangen BickNickServoDown < 31_300
                 // minDownNickServo  = 31300;  
                 // - Down   min: 31_300 da bei tracking schon bei 31_274 Collision Podest
                         
                 if(newNickServo < minDownNickServo) 
                    {
                       newNickServo = minDownNickServo; 
                       printf("BigNickServoDown\n");
                    }
                  
                 antw = newNickServo;
                 ext_servoTrackControl();
                       
                 //printf("BoxBox.y: %d , CamY: %d\n",Box.y,camy); 
                 //printf("Box: UNTENLINKS NewNickServo: %d , NickServo2: %d\n",newNickServo,NickServo2);
                 
                 if((Box.y > 230 ) && (Box.y < 250))  
                    {
                       boxDoneULy = true;
                       printf("BoxTrack_Y Done\n");
                    }           
                 
                 if((boxDoneULx == true) && (boxDoneULy == true))
                    {
                       printf(" All Done\n");
                            
                       // new Stuff
                       goto endFunc;
                    }
              } // end untenlinks
        } // end oben/untenlinks
 
     if((obenrechts == true) || (untenrechts == true))
        {           
           if(obenrechts == true) 
              {  
                 // TURNSERVO
                 turnStep = 20;
                 newTurnServo = TurnServo3 + turnStep;
                       
                 antw = newTurnServo;   
                 ext_servoTrackControl();  
                 
                 printf("ObenRechts\n");
                 //printf("BoxBox.x: %d, CamX: %d\n",Box.x,camx); 
                 //printf("Box: OBENRECHTS NewTurnServo: %d , TurnServo3: %d \n",newTurnServo,TurnServo3);
                      
                 if((Box.x > 300 ) && (Box.x < 340))  
                    {
                       boxDoneORx = true;
                       printf("BoxTrack_X Done\n");
                    }   
                 
                 // NICKSERVO 
                 nickStep = 20;
                 newNickServo = NickServo2 + nickStep; 
                              
                 antw = newNickServo;
                 ext_servoTrackControl();
                 
                 //printf("Box.y: %d , CamY: %d\n",Box.y,camy); 
                 //printf("Box: OBENRECHTS NewNickServo: %d , NickServo2: %d\n",newNickServo,NickServo2);
                 
                 if((Box.y > 220 ) && (Box.y < 260))  
                    {
                       boxDoneORy = true;
                       printf("BoxTrack_Y Done\n");
                    }           
                 
                 if((boxDoneORx == true) && (boxDoneORy == true))
                    {
                       printf(" All Done\n");
                            
                       // new Stuff
                       goto endFunc;
                    }
              }
           if(untenrechts == true) 
              {
                 // TURNSERVO
                 turnStep = 20; 
                 newTurnServo = TurnServo3 + turnStep;
                       
                 antw = newTurnServo;   
                 ext_servoTrackControl();
                 
                 printf("UntenRechts\n");
                 //printf("Box.x: %d, CamX: %d\n",Box.x,camx); 
                 //printf("Box: UNTENRECHTS NewTurnServo: %d , TurnServo3: %d \n",newTurnServo,TurnServo3);
                  
                 if((Box.x > 300 ) && (Box.x < 340))  
                    {
                       boxDoneURx = true;
                       printf("BoxTrack_X Done\n");
                    }   
                                     
                 // NICKSERVO
                 nickStep = 10; 
                 newNickServo = NickServo2 - nickStep;    // old + 
                       
                 // Abfangen BickNickServoDown < 31_280
                 // minDownNickServo  = 31280;  
                 // - Down   min: 31_280 da bei tracking schon bei 31_274 Collision Podest
                        
                 if(newNickServo < minDownNickServo) 
                    {
                       newNickServo = minDownNickServo; 
                       printf("BigNickServoDown\n");
                    }
                 
                 antw = newNickServo;
                 ext_servoTrackControl();
                      
                 //printf("Box.y: %d , CamY: %d\n",Box.y,camy); 
                 //printf("Box: UNTENRECHTS NewNickServo: %d , NickServo2: %d\n",newNickServo,NickServo2);
                 
                 if((Box.y > 220 ) && (Box.y < 260))  //== bcamx)
                    {
                       boxDoneURy = true;
                       printf("BoxTrack_Y Done\n");
                    }           
                  
                 if((boxDoneURx == true) && (boxDoneURy == true))
                    {
                       printf(" All Done\n");
                            
                       // new Stuff
                       goto endFunc;
                    }
              } // end untenrechts
        } // end oben/unten rechts
     
     // new stuff
     endFunc:;  

     // einstieg von Winglets-ServoMovements
     // um unnoetige ServoTracks zu vermeiden
     // AUSDOKUMENTIERT da diese version nur angesprungen wird
     // wenn red-ball-track = true
            
     if(wingServo > 51301)
        {  
           antw = wingServo;
           printf("WingletServoAntw: %d\n",antw);
           printf("Now Winglets Move\n");
           // uebergabe an ServoTracking with
           
           ext_servoTrackControl();
        }
     
  }     
 
      
/**************************************************************************************************/
// new trackCalc dd. 15.10.09
// new Function as:
void trackCalc()
  { 
     printf("TrackCalc\n");
     
     printf("Box.x: %d, Box.y: %d\n",Box.x,Box.y);
     printf("CamX: %d, CamY: %d\n",camx,camy);   
     
     // (1) obenLinks:   
     if((Box.x < camx) && (Box.y < camy))
        {
           obenlinks = true;
           
           printf("RedBox: ObenLinks\n");
            
           // now draw a BX-Line to the center of the images:
           cvLine(frame1,cvPoint(Box.x,Box.y),cvPoint(Box.x,camy),cvScalar(0x00,0xff,0xff),4,8);  
           // now draw a AY-Lineine to the center of the images:
           cvLine(frame1,cvPoint(Box.x,camy),cvPoint(camx,camy),cvScalar(0x00,0x00ff,0xff),6,8);  
        }     
     
     // (2) obenrechts
     if((Box.x > camx) && (Box.y < camy))
        {
           obenrechts = true;
           
           printf("RedBox: ObenRechts\n");

           // now draw a BX-Line to the center of the images:
           cvLine(frame1,cvPoint(Box.x,Box.y),cvPoint(Box.x,camy),cvScalar(0x00,0xff,0xff),4,8);  
           // now draw a AY-Lineine to the center of the images:
           cvLine(frame1,cvPoint(Box.x,camy),cvPoint(camx,camy),cvScalar(0x00,0x00ff,0xff),6,8);  
        }
     
     // (3) untenRechts:
     if((Box.x > camx) && (Box.y > camy))
        {
           untenrechts = true;
           
           printf("RedBox: UntenRechts\n");

           // now draw a BX-Line to the center of the images:
           cvLine(frame1,cvPoint(Box.x,Box.y),cvPoint(Box.x,camy),cvScalar(0x00,0xff,0xff),4,8);  
           // now draw a AY-Lineine to the center of the images:
           cvLine(frame1,cvPoint(Box.x,camy),cvPoint(camx,camy),cvScalar(0x00,0x00ff,0xff),6,8);  
        }
     
     // (4) untenLinks : 
     if((Box.x < camx) && (Box.y > camy))
        {
           untenlinks = true;
           
           printf("RedBox: UntenLinks\n");

           // now draw a BX-Line to the center of the images:
           cvLine(frame1,cvPoint(Box.x,Box.y),cvPoint(Box.x,camy),cvScalar(0x00,0xff,0xff),4,8);  
           // now draw a AY-Lineine to the center of the images:
           cvLine(frame1,cvPoint(Box.x,camy),cvPoint(camx,camy),cvScalar(0x00,0x00ff,0xff),6,8);  
        }
      
     // 4.version von trackServo
     if( RED_BALL_TRACK == true)
        {
           printf("Now RedBallServoTracking\n");   
           RedTrackServo();
        }
         
     obenlinks   = false;
     obenrechts  = false;
     untenrechts = false;
     untenlinks  = false;
 
     boolTarget  = false;   

  } 

/**************************************************************************************************/
int redBallStateMachine()
  {
     WANT_SENSOR_DATAS_KEYs = true;

     ext_SensorCommunications();

     printf("\n\nRed-BallStateMachine\n");
     printf("PING Range_cm: %f\n",range_cm);

     // FEAR -> VERRY SMALL  
     if(range_cm < 7.5) 
        {
          // from simBehavoir0206E
          printf("FEAR\n"); 
          // neuralNet
          W_31 = (max_range_cm - range_cm) * w_pingFac; 
          W_32 = (W_32 + W_31) / 2.0; 

          /* 
             AUDIO WITH FESTIVAL
             2 = letter2.txt == oooh, Yeah
             3 = letter3.txt == TschindradaBumps.
         */    
         ext_audioWrite( 2 ); // int antw);

          mimikryFearPoseLeft();
        }
     // ANGRY -> SMALL
     if((range_cm > 7.5) && (range_cm < 12.50))
        {
           // from simBehavior0206E
           printf("ANGRY\n"); 
           // neuralNet
           W_31 = (max_range_cm - range_cm) * w_pingFac; 
           W_32 = (W_32 + W_31) / 2.0; 

           /* 
             AUDIO WITH FESTIVAL
             2 = letter2.txt == oooh, Yeah
             3 = letter3.txt == TschindradaBumps.
           */    
           ext_audioWrite( 3 ); // int antw);

           mimikryAngryNick();
        }
     // NOTHING TODOs
     if(range_cm > 13.0)
        {
           printf("OUTSIDE\n");
           W_31 = 0.7 + ((max_range_cm - range_cm) * w_pingFac); 
           W_32 = 0.5 + ((W_32 + W_31) / 2.0); 
        } 

     printf("RedBallStateMachine: W_31: %f, W_32: %f\n", W_31,W_32);
     // aka 
     // W_31 = (max_range_cm - range_cm) * w_pingFac; 
     // W_32 = (W_32 + W_31) / 2.0;
    
  }
/************************************************************************************************/
// ex. void Behavior()
/************************************************************************************************/
// ex mimikryRoll & mimikryNick into simBehavior0206.cpp as experimental           
/************************************************************************************************/
void paint_red(IplImage *frame, Display *dpy) 
  {
     int xmin, xmax, ymin, ymax;

     int top = HEIGHT, bottom = -1, left = WIDTH, right = -1;
           
     if(searchx == -1 || searchy == -1) 
        {
           xmin = 0;
           ymin = 0;
           xmax = WIDTH;
           ymax = HEIGHT;
        } 
     else 
        {
           xmin = MAX (0, searchx - SEARCHRANGE);
           xmax = MIN (WIDTH, searchx + SEARCHRANGE);
           ymin = MAX (0, searchy - SEARCHRANGE);
           ymax = MIN (HEIGHT, searchy + SEARCHRANGE);
        }
            
     RgbImage image (frame);
           
     int redxt = 0, redyt = 0;
     int count = 0;
           
     for(int i = ymin; i < ymax; i++) 
        {
           for(int j = xmin; j < xmax; j++) 
              {
                 int r = image[i][j].r;
                 int g = image[i][j].g;
                 int b = image[i][j].b;
                 
             
           /* 
                 if((HEAD_TRACK == false) && (RED_BALL_TRACK == false))
                    {
                       printf("NO TRACKING POSSIBLE\n");
                       LEARNING = true; 

                       // mimikryRoll();

                       goto ende;
                    }
                 
                 ende1:;

                 if((HEAD_TRACK == true) || (RED_BALL_TRACK == true))
                    {
                       printf("TRACKING POSSIBLE\n");

                  //     mimikryNick();
                    }   
           */   
                 // Here NEW SWITCHING REDBALL-TRACKING AND
                 // BODY-TRACKING           
                 // original =>  REDBALL
                 if(g < 0x20 && b < 0x20 && r > 0x80) 
                    {
                       image[i][j].r=0xFF;
                       image[i][j].g=0x00;
                       image[i][j].b=0x00;
                       redyt += i;
                       redxt += j;
                       count++;
                             
                       top = MIN (top, i);
                       bottom = MAX (bottom, i);
                       left = MIN (left, j);
                       right = MAX (right, j);
                    }
              }
        }
            
     boolSetPoints = false;
           
     if(count) 
        {
           searchx = redxt / count;
           searchy = redyt / count;
                  
           float redx = (float) redxt / count / WIDTH;
           float redy = (float) redyt / count / HEIGHT;
                  
           int screenx = (int)(redx * 1480.0 - 100);
           int screeny = (int)(redy * 1000.0 - 100);
                  
           topleft = cvPoint (left, top);
           bottomright = cvPoint (right, bottom);
                 
           CvRect box;
                  
           box.x = (int)(left+((left-right)/2)*(-1));
           box.y = (int)(top+((top-bottom)/2)*(-1));
                  
           boolSetPoints = true; 
                  
           Box.x = box.x;
           Box.y = box.y;
                                                                                     // yellow
           cvRectangle(frame1,cvPoint(Box.x-20,Box.y-20),cvPoint (Box.x+20,Box.y+20),cvScalar(0x00,0xff,0xff), 8, 1);
    
           RED_BALL_TRACK = true;

           trackCalc();  

           // for winglets
       //    Xf0 = 95.0;
       //    weight0 = 1.50;             
        
           int thish = bottom - top;
           int thisw = right - left; 
                 
           if(shapechange && abs(lasth - thish) < lasth * 1 - CHANGEFACTOR) 
              { 
                 if(shapechange == CHANGE_GROWING)
                    state = STATE_UP;
                 else
                    state = STATE_DOWN;
              }
                 
           if(thish < lasth * CHANGEFACTOR) shapechange = CHANGE_SHRINKING;
           else if (thish * CHANGEFACTOR > lasth) shapechange = CHANGE_GROWING;
           else shapechange = CHANGE_NONE;
                 
           lasth = thish;
           lastw = thisw;
                 
           XFlush (dpy);

           printf("\n\n(1) RED_BALL_TRACK == %d\n\n",RED_BALL_TRACK);          
        } 
     else 
        {
           searchx = -1;
           searchy = -1;
           RED_BALL_TRACK = false;

           printf("\n\n(2) RED_BALL_TRACK == %d\n\n",RED_BALL_TRACK);

           // for winglets
       //    Xf0 = 75.0;
       //    weight0 = 3.0; 
        }
     
   //  ende:;  
  }
/**************************************************************************************************/
void ext_RedTracking()
  {
     centerx = 320;
     centery = 240;
                                                                                          // cvScalar(128,128,128);             
     cvRectangle( frame1, cvPoint(centerx-20,centery-20), cvPoint(centerx+20,centery+20), cvScalar(256,256,256), 8, -1 );  

     // ev. changing or erweitern da 2 x frame
     int step = frame1->widthStep / sizeof (uchar);
      
     // cvRedTrack Right 
     paint_red( frame1, dpy );
     
     Behavior();
     
     // new
     redBallStateMachine(); // stateMachine();     
        
  }
                 
/************************************************************************************************/ 
             
