//============================================================================================//
//    The Nomad-Head-System-Project                                                   
//    by                                                                    
//    Rytta Communications Inc.                                           
//    (c) Version 0.207. March 2010 
//
//    EXPERIMENTAL -> TESTING NEW CONCEPTS                                       
//    Stripping OpenGL only OpenCV & SerialCom     
//    for NomadHeadSystem incl. Winglets
//           
//===========================================================================================// 
//     servoTracking0207.cpp    
//     ---------------------    
//     
//     begin     : Thursday 11. March 10.15:00 GMT 2010                            
//     copyright : (C) 2008/2010 by  s.morf 
//     email     : stevenmorf@bluewin.ch 
//     originalCompile with   
//     opencv & pthreads:  
//     g++ -I/usr/local/include/opencv -L /usr/local/lib -lcxcore -lcv -lhighgui -lcvaux -lml -o NomadHeadSystem011 NomadHeadSystem011 -lm -lpthread

//     compileScript: ./compileScript_87.sh 
//
//     as           : - Main: nomadHeadSystem0207.cpp  
//                    - Sub1: redBallTracking0207.cpp
//                    - Sub2: servoTracking0207.cpp
//                    - Sub3: headSensor0207.cpp
//                    - Sub4: bodyTracking0207.cpp
//                    - Sub5: simBehavior02067.cpp
//                    - Sub6: audioWriter0207.cpp
//     
//     run as    : ./nomadHeadSystem0207
//
//    for: 
//    Basics of : - ComputerVisions with 2 USB-WebCams as Eyes
//                  - with (pthreads options)
//                  - OpenCV 
//                    - 2 x WebCams
//                  - comControl with  
//                    - SerialControl of CamHeadSystem via PropDevBoard
//                      - 3 DOF (Nick & Turn & opt.Roll)
//                      - horizontal Turns of CamServos                
//                  - PingHeadSensor on PPDB 
//                    - Ping DistanceMeter
//                  - with 2 x Winglets with 2x microServos
//                  - Audio with Laptop FESTIVAL 
/*************************************************************************************************
References:

  Copyright (C) 2007 Julian Oliver
  http://julianoliver.com

  Modifications
  Copyright (C) 2008 Jean-Philippe Deblonde
  http://www.lifl.fr/~deblonde/

  verwendete programme:
  from /root/Desktop/OPENCV/opencv-tutorial.pdf (german)
  <Bildverarbeitung mit OpenCV, author Johannes Wienke, Uni Bielefeld 2008>

  OpenCV_Beispiele From RoboWeb
  Mehrere Bilder in einem Fenster
  from http://opencvlibrary.sourceforge.net/DisplayManyImages.

  Display video from webcam

  lucasKanadeAlgorithmus: from
  cvLkDemo1.cpp from samples/c/ (lkdemo.c -> erkennt face (frontal)
  lkdemo.c from book "learning opencv" /samples/c/
  if <r> automatical Init
  "Learning OpenCV-Book"
 
  Author  Nash
  License GPL
  Website http:/nashruddin.com

  OpticalFlow from
  David Stavens
  Standford Artificial Intelligence Lab (PDF)

  3d distance tracking using head width
  name: headtracking1.cpp
  from:http://code.google.com/p/ehci/wiki/HeadTracking
 
  Ref: This code uses some approximations, but is a good starting point

//************************************************************************************************/ 
//     THIS PROGRAMM IS UNDER THE GNU-LICENCE                              
/*************************************************************************************************  
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE#  sub3: RedTrackCommunications0400.cpp     v7
#  sub4: HeadTrackCommunications0400.cpp    v4
#  sub4: HandGestureCommunications0400.cpp  v1
#.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*************************************************************************************************/ 
// Sample Application to demonstrate how Face detection can be done as a part of your source code.
// as *.cpp source
// Grabbing Images from two cameras simultaneously
// Note: Here we are using USB cameras 
/*************************************************************************************************
NOTES:
---------------------------------------------------------------------------------------------------
REFERENCES FOR SERVO-MOVEMENTS AFTER NEW PIN-BELEGUNG:
------------------------------------------------------
Pin-Belegungen:
- CamServo0  -> P0
- RollServo1 -> P1
- NickServo2 -> P2
- TurnServo3 -> P3
- WingServo  -> P4

 - CamServo0: PIN 0
   - Center: 1_500  -> 11_500  OK   
   - Left  : 1_250  -> 11_250  OK           
   - Right : 1_750  -> 11_750  OK           

 - RollServo1: PIN 1                            
   - Center: 1_660  -> 21_660  OK     
   - Left  : 1_700  -> 21_700  OK    
   - Right : 1_620  -> 21_620  OK 
          
 - NickServo2: PIN 2
   - Center: 1_400  -> 31_400 OK 
   - UP    : 1_600  -> 31_600 OK            
   - Down  : 1_300  -> 31_300 OK            
     
 - TurnServo3: PIN 3
   - Center: 1_400  -> 41_400  OK   
   - Left  : 1_000  -> 41_000  OK ca  45 deg  
   - Right : 1_800  -> 41_800  OK ca  45 deg    
     
 - WingLetsServo  PIN 4             
   - Center                  : 1_300   -> 51_300
   - WingLets Anheben max.UP : 1_950   -> 51_950   max.Right 2_000  
   - WingLets Senken min.Down: 1_300   -> 51_300   min.Left  1_000                    
                 
-------------------------------------------------------------------------------------------------
References:
- 1) HeadSensor PING via PropellerDevBoard
     - Pin = P5
     - input: range_mm = kann auch range_cm generieren
- 2) - Serial-Comm to PPDB (rs232)
       - HeadServoControl 
         - cvRobot2CamHeadGluiControl14.cpp with 2 x WebCams & GLUI
- 3) - Loudspeaker:SoundCheck10.c
       - verknuepfung tplay & explode.wav
         - little prog testing soundplay
           as: system("./tplay explode.wav")
- 4) - OpenCV:
       -LucasKanade -> CamHeadSystem0461.cpp
       -cvRedGloves10.cpp 

/*************************************************************************************************/

#include<iostream>

// c
#include <math.h>

// C-Stuff for RS232
#include <stdio.h>
#include <stdlib.h>

#include <fcntl.h> 
#include <string.h> 
#include <ctype.h> 

#include <setjmp.h> 
#include <termios.h> 
#include <unistd.h> 
#include <sys/signal.h> 
#include <sys/types.h> 
#include <errno.h> 

#include <ctype.h>
#include <sys/io.h> 
// glui
#include <sys/stat.h>
#include <stdarg.h>
#include <assert.h>
#include <float.h>
#include <limits.h>
#include <time.h>

#include <sstream>
 
using namespace std;

/***************************************************************************************************/
#define _POSIX_SOURCE 1  	    // POSIX compliant source  

// new for communications 

#define BAUDRATE_PROP   B9600   // baudrate settings for commands mots                                 

// here noch aendern
#define MODEMDEVICE_PROP "/dev/ttyUSB0"  // on QUAD !! NO CHANGE IF 2 USBWEBCAMS ON USBPORTS 

#define MAXTOKLEN 255  // for tokenizer
#define BUFLEN 255
#define S_MAXTOKLEN 8

struct termios oldtio,newtio, options; 

int fw_prop;     // w=write 
int fr_prop;     // r=read
int res;
int rescommand;
int s_len;

char combuf[255]; 
char buffer[BUFLEN];
char buf[255];
char s_buffer[BUFLEN];

int inputs;

// sendCommands to mc
char *sendDataStr;
char *recDataStr;

char sendData[12];  // for umwandlung int to string with sprintf
const char *sendEOF = ("\r");

//char buffer [50];  // example bei sprintf
int n; 
int exits;
int antw; // for output
int i;    // counter

int CamServo0  = 11500;  // 11500
int RollServo1 = 21660;  // new Head guckt geradeaus  old: 21_660 
int NickServo2 = 31400;  // new Head guckt geradeaus mit Schale  Kinn on whiteBlock old: 31_340;  
int TurnServo3 = 41400;  
int WingServo  = 51300;  // old 51500 winglets = Neutral angelegt

int newCamServo  = 11500;
int newRollServo = 21660;
int newNickServo = 31400; 
int newTurnServo = 41400;
int newWingServo = 51300;  // old 51_500 angelegt neural center

// new dd. 16.02.2010 & 18.02.2010 & 02.03.2010
// MIN/MAX - ServoValues
// - CamServo:
int minLeftCamServo   = 11250;  // - left  min: old 11_350    
int maxRightCamServo  = 11750;  // - Right max: old 11_650 
// - RollServo:
int maxLeftRollServo  = 21700;  // - left  max: old 21_750  
int minRightRollServo = 21620;  // - Right min: old 21_550  
// - NickServo:
int maxUpNickServo    = 31600;  // - UP    max: 31_600 
int minDownNickServo  = 31300;  // - Down  min: 31_280 
// - TurnServo:
int minLeftTurnServo  = 41000;  // - left   min: 41_200 
int maxRightTurnServo = 41800;  // - right  max: 41_600   
// - WingServo:
int minLeftWingServo  = 51300;  // - left   min: 51_300 = DOWN CENTER
int maxRightWingServo = 51950;  // - right  max: 51_950 = UP  
                                  
int pulses;

int minPulses = 250;
int maxPulses = 1250;

int centerAllServos  = 100;
int centerCamServo0  = 101;
int centerRollServo1 = 102;
int centerNickServo2 = 103;
int centerTurnServo3 = 104;   
int centerWingServo  = 105;

int exitPPDB = 10;

int turnstep;
int old_turnstep;
int new_turnstep;

bool bool_doNothing;

bool bool_Go;
bool bool_Done;
bool bool_ReaderDone;
bool bool_SenderDone;
bool bool_Init;

// new sequences

int oldState;
int remote_cnt;
int stop_cnt;
int left_cnt;
int right_cnt;
int cnt_1;
int cnt;
int comDoneInt = 5;

bool comDone;

// opencv from OpenCV_GL.c
int height, width, count, init;

// servoStuff
int clicks = 10;
int camClick;
int rollClick;
int nickClick;
int turnClick;
int wingClick;

/*** externe vars ***********************************************************************/

extern bool CAMSERVO_LEFT_KEY1;
extern bool CAMSERVO_RIGHT_KEY2;
extern bool ROLLSERVO_LEFT_KEY3;
extern bool ROLLSERVO_RIGHT_KEY4;
extern bool NICKSERVO_UP_KEY5;
extern bool NICKSERVO_DOWN_KEY6;
extern bool TURNSERVO_LEFT_KEY7;
extern bool TURNSERVO_RIGHT_KEY8;
extern bool CENTER_SERVOS_100_KEYc;

extern bool WANT_SENSOR_DATAS_KEYr;
extern bool SERIAL_SENDDATAS_KEYs;

extern bool quit;
extern bool done;

/*************************************************************************** 
* Don't forget to give the appropriate serial ports the right permissions  *
* (e. g.: chmod a+rw /dev/ttyS0)!                                          *
* baudrate settings are defined in <asm/termbits.h>, which is              *       
* included by <termios.h>   ==  system(init_1);                            *  
**************************************************************************** 
/*** from conio.h *********************************************************/

void gotoxy(int x, int y) { printf("\033[%d;%dH", y, x); fflush(stdout); }
void clrscr(void)         { printf("\033[H\033[J");      fflush(stdout); }

// delay (nnn)
void delay(long millisek)
{
   int mikrosek = millisek*1000;
   struct timeval  timeout;

   timeout.tv_sec  = mikrosek / 1000000L;
   timeout.tv_usec = mikrosek % 1000000L;
   select(0, NULL, NULL, NULL, &timeout);
}
/*** Serial-CamHeadSystem **********************************************************************/ 
int Reader()
  {
     int x;  
  
     fr_prop = open(MODEMDEVICE_PROP, O_RDONLY | O_NOCTTY );
     if(fr_prop <0)
        {
           perror(MODEMDEVICE_PROP);
           printf("cannot open ttyUBS0");         
           exit(-1); 
        }
     
     tcgetattr(fr_prop,&oldtio);          // save current serial port settings 
     bzero(&newtio,sizeof(options));      // clear struct for new port settings 
     fcntl(fr_prop, F_SETFL,0);
     
     if(tcgetattr(fr_prop, &options) != 0) return(-1);
     
     cfsetspeed(&options,B9600); 

     // setze Optionen 
     options.c_cflag &= ~PARENB;  // NO PARITYBIT
     options.c_cflag &= ~CSTOPB;  // 1 STOPPBIT
     options.c_cflag &= ~CSIZE;   // 8 DATENBIT 
     options.c_cflag |= CS8;
     options.c_cflag |= (CLOCAL | CREAD);  // CD-SIGNAL IGNORE
     
     options.c_lflag &= ~(ICANON | ECHO | ECHOE | ISIG);
     
     options.c_oflag &= ~OPOST;  // SETZE RAW-INPUT
     
     options.c_cc[VTIME]  = 10;    // TIMEOUT 10 SEKUNDEN  
     options.c_cc[VMIN]  = 0;      // wait auf min. 0 zeichen old blocking read  until 1 character arrives  
     
     // now clean the modem line and activate the settings for the port  
     tcflush(fr_prop, TCIFLUSH);
  
     if(tcsetattr(fr_prop,TCSAFLUSH, &options) != 0) return (-1); 

     comDone = false;
     
     while( !comDone)
        {  
           res = read(fr_prop,buf,255);
           buf[res]=0;                     // set end of string, so we can printf 

           rescommand = res;

           x++;
          
           inputs = atoi(buf);
           comDoneInt = 5;   
           
           if(comDoneInt == inputs)
              {
                 // comDone = true;
                 printf("Reader OK\n");
                 // antw = 0;
                 break;
              }

        }

     /* restore the old port settings */
     tcsetattr(fr_prop,TCSANOW,&oldtio); 
     
     close(fr_prop);
  }
/***************************************************************************************************/
int Sender()
  {
     fw_prop = open(MODEMDEVICE_PROP, O_WRONLY | O_NOCTTY );        // old O_RDWR 
     if(fw_prop <0)
        {
           perror(MODEMDEVICE_PROP);
           printf("cannot open ttyUSB0");         
           
           exit(-1); 
        }
     tcgetattr(fw_prop,&oldtio);                // save current serial port settings 
     bzero(&newtio,sizeof(options));        // clear struct for new port settings 

     fcntl(fw_prop, F_SETFL,0);
     if(tcgetattr(fw_prop, &options) != 0) return(-1);
     
     cfsetspeed(&options,B9600); 

     //setze Optionen 
     options.c_cflag &= ~PARENB;  // NO PARITYBIT
     options.c_cflag &= ~CSTOPB;  // 1 STOPPBIT
     options.c_cflag &= ~CSIZE;   // 8 DATENBIT 
     options.c_cflag |= CS8;
     options.c_cflag |= (CLOCAL | CREAD);  // CD-SIGNAL IGNORE
     // kein echo, keine steuerzeichen, keine interrupts
     
     options.c_lflag &= ~(ICANON | ECHO | ECHOE | ISIG);
     
     options.c_oflag &= ~OPOST;  // SETZE RAW-INPUT
     
     options.c_cc[VTIME] = 10;     // TIMEOUT 10 SEKUNDEN  
     options.c_cc[VMIN]  = 0;      // wait auf min. 0 zeichen old blocking read  until 1 character arrives  
  
     // now clean the modem line and activate the settings for the port  
     tcflush(fw_prop, TCIFLUSH);
  
     if(tcsetattr(fw_prop,TCSAFLUSH, &options) != 0) return (-1); 
      
     // here new write to PPDB in c
     write(fw_prop,sendDataStr,s_len);  // len: old 2
        
     /* restore the old port settings */
     
     tcsetattr(fw_prop,TCSANOW,&oldtio); 
     close(fw_prop);
          
     bool_SenderDone = false;
           
  } // end Sender  
/***************************************************************************************************/
void SendData()        
  { 
     Sender(); 
     Reader();
  }
/***************************************************************************************************/
int servoControl()
  {
     printf("ServoControl\n");

     if(antw > 0)
        {
           n = sprintf (sendData, "%d ", antw);
           // printf ("[%s] is a %d char long string\n",sendData,n);
           // printf("SendData: %s\n",sendData); 
          
           sendDataStr = (char *)malloc(strlen(sendData));  
           strcpy(sendDataStr,sendData); 
            
           s_len = strlen(sendEOF); 
           strncat(sendDataStr,sendEOF,s_len); 
           s_len = strlen(sendDataStr); 
    
           // printf("SendDataString: %s\n",sendDataStr);

           SendData();
        }   
     else
        { 
           comDone = true; 
           // printf("Back to the Clip... \n");
        }   
        
  }    
/************************************************************************************************/
int ext_servoTrackControl()
  {
     printf("ServoTrackControl\n");

     if(antw > 0)
        {
           n = sprintf (sendData, "%d ", antw);
           // printf ("[%s] is a %d char long string\n",sendData,n);
           // printf("SendData: %s\n",sendData); 
          
           sendDataStr = (char *)malloc(strlen(sendData));  
           strcpy(sendDataStr,sendData); 
            
           s_len = strlen(sendEOF); 
           strncat(sendDataStr,sendEOF,s_len); 
           s_len = strlen(sendDataStr); 
    
           printf("SendDataString: %s\n",sendDataStr);

           SendData();
        } 
    
  }   
/*************************************************************************************************/
void ext_setServoValuesCenter()
  {
     CamServo0  = 11500;  // 11500
     RollServo1 = 21660;  // new Head guckt gerade aus old 21_600 
     NickServo2 = 31400;  // new Head guckt geradeaus mit schale Kinn on whiteBlock old: 31_340;  
     TurnServo3 = 41400;  
     WingServo  = 51300;   
  } 
/*************************************************************************************************/
/* for SingleServosSetCenter with 100, 101, 102, 103, 104 
   centerAllServos  = 100;
   centerCamServo0  = 101;
   centerRollServo1 = 102;
   centerNickServo2 = 103;
   centerTurnServo3 = 104;   
   centerWingServo  = 105;
   AllServoCenter < c > bleibt bestehen = 100 or <centerAllServos>
*/
int ext_specialSingleServoCenterControl(int antw)
 {
     //printf("Single CenterServoControl\n");
  
     if((antw >= 100) || (antw <= 105))
        {
           if(antw == 100)
              {
                 ext_setServoValuesCenter();
              }  
           if(antw == 101) centerCamServo0  = 11500;
           if(antw == 102) centerRollServo1 = 21660;
           if(antw == 103) centerNickServo2 = 31400;  // old 31_340
           if(antw == 104) centerTurnServo3 = 41400;  
           if(antw == 105) centerWingServo  = 51300;  // old 51_500
              
           n = sprintf (sendData, "%d ", antw);
           //printf ("[%s] is a %d char long string\n",sendData,n);
                   
           //printf("SendSingleCenterServoData: %s\n",sendData); 
          
           sendDataStr = (char *)malloc(strlen(sendData));  
           strcpy(sendDataStr,sendData); 
            
           s_len = strlen(sendEOF); 

           // new antw auf 0 setzen
                 
           strncat(sendDataStr,sendEOF,s_len); 
                 
           s_len = strlen(sendDataStr); 
           //printf("S_Len: %d\n",s_len); 
           printf("SendDataString <100>: %s\n",sendDataStr);

           antw = 0;

           SendData();
        }   
     else
        { 
           comDone = true; 
           printf("ComDone... \n");
        }   
  }    

/*************************************************************************************************/

void ext_SerialServoControl()
  {
     // 0old stuff with : if(CENTER_SERVOS_100_KEYc == true)
      
     antw = centerAllServos; //  = 100; 
     ext_setServoValuesCenter(); 
     printf("Center All Servos with: %d\n",antw);
           
     ext_servoTrackControl();
        
      // ESC Button clicked
	  if(quit == true)
        {
           antw = exitPPDB; //  = 10;
			  printf ("Quit Button clicked Send ExitSignal to PPDB with: %d\n",antw);
           servoControl();
           printf("Exit!.... bye,bye\n");
               
			  exit (1);
		  }
  }
/***************************************************************************************************/
